// Code generated by pigeon; DO NOT EDIT.

package nosql

import (
	"bytes"
	"errors"
	"fmt"
	"io"
	"math"
	"os"
	"sort"
	"strconv"
	"strings"
	"sync"
	"unicode"
	"unicode/utf8"

	"github.com/pikami/cosmium/parsers"
)

func makeSelectStmt(
	columns, fromClause, joinItems,
	whereClause interface{}, distinctClause interface{},
	count interface{}, groupByClause interface{}, orderList interface{},
	offsetClause interface{},
) (parsers.SelectStmt, error) {
	selectStmt := parsers.SelectStmt{
		SelectItems: columns.([]parsers.SelectItem),
	}

	if fromTable, ok := fromClause.(parsers.Table); ok {
		selectStmt.Table = fromTable
	}

	if joinItemsArray, ok := joinItems.([]interface{}); ok && len(joinItemsArray) > 0 {
		selectStmt.JoinItems = make([]parsers.JoinItem, len(joinItemsArray))
		for i, joinItem := range joinItemsArray {
			selectStmt.JoinItems[i] = joinItem.(parsers.JoinItem)
		}
	}

	switch v := whereClause.(type) {
	case parsers.ComparisonExpression, parsers.LogicalExpression, parsers.Constant, parsers.SelectItem:
		selectStmt.Filters = v
	}

	if distinctClause != nil {
		selectStmt.Distinct = true
	}

	if n, ok := count.(int); ok {
		selectStmt.Count = n
	}

	if offsetArr, ok := offsetClause.([]interface{}); ok && len(offsetArr) == 2 {
		if n, ok := offsetArr[0].(int); ok {
			selectStmt.Offset = n
		}

		if n, ok := offsetArr[1].(int); ok {
			selectStmt.Count = n
		}
	}

	if orderExpressions, ok := orderList.([]parsers.OrderExpression); ok {
		selectStmt.OrderExpressions = orderExpressions
	}

	if groupByClause != nil {
		selectStmt.GroupBy = groupByClause.([]parsers.SelectItem)
	}

	return selectStmt, nil
}

func makeJoin(table interface{}, column interface{}) (parsers.JoinItem, error) {
	joinItem := parsers.JoinItem{}

	if selectItem, isSelectItem := column.(parsers.SelectItem); isSelectItem {
		joinItem.SelectItem = selectItem
		joinItem.Table.Value = selectItem.Alias
	}

	if tableTyped, isTable := table.(parsers.Table); isTable {
		joinItem.Table = tableTyped
	}

	return joinItem, nil
}

func makeSelectItem(name interface{}, path interface{}, selectItemType parsers.SelectItemType) (parsers.SelectItem, error) {
	ps := path.([]interface{})

	paths := make([]string, 1)
	paths[0] = name.(string)
	for _, p := range ps {
		paths = append(paths, p.(string))
	}

	return parsers.SelectItem{Path: paths, Type: selectItemType}, nil
}

func makeColumnList(column interface{}, other_columns interface{}) ([]parsers.SelectItem, error) {
	collsAsArray := other_columns.([]interface{})
	columnList := make([]parsers.SelectItem, len(collsAsArray)+1)
	columnList[0] = column.(parsers.SelectItem)

	for i, v := range collsAsArray {
		if col, ok := v.(parsers.SelectItem); ok {
			columnList[i+1] = col
		}
	}

	return columnList, nil
}

func makeSelectArray(columns interface{}) (parsers.SelectItem, error) {
	return parsers.SelectItem{
		SelectItems: columns.([]parsers.SelectItem),
		Type:        parsers.SelectItemTypeArray,
	}, nil
}

func makeSelectObject(field interface{}, other_fields interface{}) (parsers.SelectItem, error) {
	fieldsAsArray := other_fields.([]interface{})
	fieldsList := make([]parsers.SelectItem, len(fieldsAsArray)+1)
	fieldsList[0] = field.(parsers.SelectItem)

	for i, v := range fieldsAsArray {
		if col, ok := v.(parsers.SelectItem); ok {
			fieldsList[i+1] = col
		}
	}

	return parsers.SelectItem{
		SelectItems: fieldsList,
		Type:        parsers.SelectItemTypeObject,
	}, nil
}

func makeOrderByClause(ex1 interface{}, others interface{}) ([]parsers.OrderExpression, error) {
	othersArray := others.([]interface{})
	orderList := make([]parsers.OrderExpression, len(othersArray)+1)
	orderList[0] = ex1.(parsers.OrderExpression)

	for i, v := range othersArray {
		if col, ok := v.(parsers.OrderExpression); ok {
			orderList[i+1] = col
		}
	}

	return orderList, nil
}

func makeOrderExpression(field interface{}, order interface{}) (parsers.OrderExpression, error) {
	value := parsers.OrderExpression{
		SelectItem: field.(parsers.SelectItem),
		Direction:  parsers.OrderDirectionAsc,
	}

	if orderValue, ok := order.(parsers.OrderDirection); ok {
		value.Direction = orderValue
	}

	return value, nil
}

func createFunctionCall(functionType parsers.FunctionCallType, arguments []interface{}) (parsers.FunctionCall, error) {
	return parsers.FunctionCall{Type: functionType, Arguments: arguments}, nil
}

func joinStrings(array []interface{}) string {
	var stringsArray []string
	for _, elem := range array {
		str, ok := elem.(string)
		if !ok {
			continue
		}
		stringsArray = append(stringsArray, str)
	}

	return strings.Join(stringsArray, "")
}

func combineExpressions(ex1 interface{}, exs interface{}, operation parsers.LogicalExpressionType) (interface{}, error) {
	if exs == nil || len(exs.([]interface{})) < 1 {
		return ex1, nil
	}

	return parsers.LogicalExpression{
		Expressions: append([]interface{}{ex1}, exs.([]interface{})...),
		Operation:   operation,
	}, nil
}

var g = &grammar{
	rules: []*rule{
		{
			name: "Input",
			pos:  position{line: 183, col: 1, offset: 4923},
			expr: &actionExpr{
				pos: position{line: 183, col: 10, offset: 4932},
				run: (*parser).callonInput1,
				expr: &labeledExpr{
					pos:   position{line: 183, col: 10, offset: 4932},
					label: "selectStmt",
					expr: &ruleRefExpr{
						pos:  position{line: 183, col: 21, offset: 4943},
						name: "SelectStmt",
					},
				},
			},
		},
		{
			name: "SelectStmt",
			pos:  position{line: 187, col: 1, offset: 4986},
			expr: &actionExpr{
				pos: position{line: 187, col: 15, offset: 5000},
				run: (*parser).callonSelectStmt1,
				expr: &seqExpr{
					pos: position{line: 187, col: 15, offset: 5000},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 187, col: 15, offset: 5000},
							name: "Select",
						},
						&ruleRefExpr{
							pos:  position{line: 187, col: 22, offset: 5007},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 188, col: 5, offset: 5014},
							label: "distinctClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 188, col: 20, offset: 5029},
								expr: &ruleRefExpr{
									pos:  position{line: 188, col: 20, offset: 5029},
									name: "DistinctClause",
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 188, col: 36, offset: 5045},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 189, col: 5, offset: 5052},
							label: "topClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 189, col: 15, offset: 5062},
								expr: &ruleRefExpr{
									pos:  position{line: 189, col: 15, offset: 5062},
									name: "TopClause",
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 189, col: 26, offset: 5073},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 190, col: 5, offset: 5080},
							label: "columns",
							expr: &ruleRefExpr{
								pos:  position{line: 190, col: 13, offset: 5088},
								name: "Selection",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 190, col: 23, offset: 5098},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 191, col: 5, offset: 5105},
							label: "fromClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 191, col: 16, offset: 5116},
								expr: &ruleRefExpr{
									pos:  position{line: 191, col: 16, offset: 5116},
									name: "FromClause",
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 191, col: 28, offset: 5128},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 192, col: 5, offset: 5135},
							label: "joinClauses",
							expr: &zeroOrMoreExpr{
								pos: position{line: 192, col: 17, offset: 5147},
								expr: &actionExpr{
									pos: position{line: 192, col: 18, offset: 5148},
									run: (*parser).callonSelectStmt22,
									expr: &seqExpr{
										pos: position{line: 192, col: 18, offset: 5148},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 192, col: 18, offset: 5148},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 192, col: 21, offset: 5151},
												label: "join",
												expr: &ruleRefExpr{
													pos:  position{line: 192, col: 26, offset: 5156},
													name: "JoinClause",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 192, col: 60, offset: 5190},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 193, col: 5, offset: 5197},
							label: "whereClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 193, col: 17, offset: 5209},
								expr: &actionExpr{
									pos: position{line: 193, col: 18, offset: 5210},
									run: (*parser).callonSelectStmt30,
									expr: &seqExpr{
										pos: position{line: 193, col: 18, offset: 5210},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 193, col: 18, offset: 5210},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 193, col: 21, offset: 5213},
												name: "Where",
											},
											&ruleRefExpr{
												pos:  position{line: 193, col: 27, offset: 5219},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 193, col: 30, offset: 5222},
												label: "condition",
												expr: &ruleRefExpr{
													pos:  position{line: 193, col: 40, offset: 5232},
													name: "Condition",
												},
											},
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 194, col: 5, offset: 5274},
							label: "groupByClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 194, col: 19, offset: 5288},
								expr: &actionExpr{
									pos: position{line: 194, col: 20, offset: 5289},
									run: (*parser).callonSelectStmt39,
									expr: &seqExpr{
										pos: position{line: 194, col: 20, offset: 5289},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 194, col: 20, offset: 5289},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 194, col: 23, offset: 5292},
												name: "GroupBy",
											},
											&ruleRefExpr{
												pos:  position{line: 194, col: 31, offset: 5300},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 194, col: 34, offset: 5303},
												label: "columns",
												expr: &ruleRefExpr{
													pos:  position{line: 194, col: 42, offset: 5311},
													name: "ColumnList",
												},
											},
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 195, col: 5, offset: 5352},
							label: "orderByClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 195, col: 19, offset: 5366},
								expr: &actionExpr{
									pos: position{line: 195, col: 20, offset: 5367},
									run: (*parser).callonSelectStmt48,
									expr: &seqExpr{
										pos: position{line: 195, col: 20, offset: 5367},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 195, col: 20, offset: 5367},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 195, col: 23, offset: 5370},
												label: "order",
												expr: &ruleRefExpr{
													pos:  position{line: 195, col: 29, offset: 5376},
													name: "OrderByClause",
												},
											},
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 196, col: 5, offset: 5418},
							label: "offsetClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 196, col: 18, offset: 5431},
								expr: &actionExpr{
									pos: position{line: 196, col: 19, offset: 5432},
									run: (*parser).callonSelectStmt55,
									expr: &seqExpr{
										pos: position{line: 196, col: 19, offset: 5432},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 196, col: 19, offset: 5432},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 196, col: 22, offset: 5435},
												label: "offset",
												expr: &ruleRefExpr{
													pos:  position{line: 196, col: 29, offset: 5442},
													name: "OffsetClause",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "DistinctClause",
			pos:  position{line: 201, col: 1, offset: 5637},
			expr: &litMatcher{
				pos:        position{line: 201, col: 19, offset: 5655},
				val:        "distinct",
				ignoreCase: true,
				want:       "\"DISTINCT\"i",
			},
		},
		{
			name: "TopClause",
			pos:  position{line: 203, col: 1, offset: 5668},
			expr: &actionExpr{
				pos: position{line: 203, col: 14, offset: 5681},
				run: (*parser).callonTopClause1,
				expr: &seqExpr{
					pos: position{line: 203, col: 14, offset: 5681},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 203, col: 14, offset: 5681},
							name: "Top",
						},
						&ruleRefExpr{
							pos:  position{line: 203, col: 18, offset: 5685},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 203, col: 21, offset: 5688},
							label: "count",
							expr: &ruleRefExpr{
								pos:  position{line: 203, col: 27, offset: 5694},
								name: "Integer",
							},
						},
					},
				},
			},
		},
		{
			name: "FromClause",
			pos:  position{line: 207, col: 1, offset: 5729},
			expr: &choiceExpr{
				pos: position{line: 207, col: 15, offset: 5743},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 207, col: 15, offset: 5743},
						run: (*parser).callonFromClause2,
						expr: &seqExpr{
							pos: position{line: 207, col: 15, offset: 5743},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 207, col: 15, offset: 5743},
									name: "From",
								},
								&ruleRefExpr{
									pos:  position{line: 207, col: 20, offset: 5748},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 207, col: 23, offset: 5751},
									label: "table",
									expr: &ruleRefExpr{
										pos:  position{line: 207, col: 29, offset: 5757},
										name: "TableName",
									},
								},
								&labeledExpr{
									pos:   position{line: 207, col: 39, offset: 5767},
									label: "selectItem",
									expr: &actionExpr{
										pos: position{line: 207, col: 51, offset: 5779},
										run: (*parser).callonFromClause9,
										expr: &seqExpr{
											pos: position{line: 207, col: 51, offset: 5779},
											exprs: []any{
												&ruleRefExpr{
													pos:  position{line: 207, col: 51, offset: 5779},
													name: "ws",
												},
												&ruleRefExpr{
													pos:  position{line: 207, col: 54, offset: 5782},
													name: "In",
												},
												&ruleRefExpr{
													pos:  position{line: 207, col: 57, offset: 5785},
													name: "ws",
												},
												&labeledExpr{
													pos:   position{line: 207, col: 60, offset: 5788},
													label: "column",
													expr: &ruleRefExpr{
														pos:  position{line: 207, col: 67, offset: 5795},
														name: "SelectItem",
													},
												},
											},
										},
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 216, col: 5, offset: 6030},
						run: (*parser).callonFromClause16,
						expr: &seqExpr{
							pos: position{line: 216, col: 5, offset: 6030},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 216, col: 5, offset: 6030},
									name: "From",
								},
								&ruleRefExpr{
									pos:  position{line: 216, col: 10, offset: 6035},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 216, col: 13, offset: 6038},
									label: "column",
									expr: &ruleRefExpr{
										pos:  position{line: 216, col: 20, offset: 6045},
										name: "SelectItem",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 223, col: 5, offset: 6244},
						run: (*parser).callonFromClause22,
						expr: &seqExpr{
							pos: position{line: 223, col: 5, offset: 6244},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 223, col: 5, offset: 6244},
									name: "From",
								},
								&ruleRefExpr{
									pos:  position{line: 223, col: 10, offset: 6249},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 223, col: 13, offset: 6252},
									label: "subQuery",
									expr: &ruleRefExpr{
										pos:  position{line: 223, col: 22, offset: 6261},
										name: "SubQuerySelectItem",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SubQuery",
			pos:  position{line: 232, col: 1, offset: 6442},
			expr: &actionExpr{
				pos: position{line: 232, col: 13, offset: 6454},
				run: (*parser).callonSubQuery1,
				expr: &seqExpr{
					pos: position{line: 232, col: 13, offset: 6454},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 232, col: 13, offset: 6454},
							label: "exists",
							expr: &zeroOrOneExpr{
								pos: position{line: 232, col: 20, offset: 6461},
								expr: &actionExpr{
									pos: position{line: 232, col: 21, offset: 6462},
									run: (*parser).callonSubQuery5,
									expr: &seqExpr{
										pos: position{line: 232, col: 21, offset: 6462},
										exprs: []any{
											&labeledExpr{
												pos:   position{line: 232, col: 21, offset: 6462},
												label: "exists",
												expr: &ruleRefExpr{
													pos:  position{line: 232, col: 28, offset: 6469},
													name: "Exists",
												},
											},
											&ruleRefExpr{
												pos:  position{line: 232, col: 35, offset: 6476},
												name: "ws",
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 232, col: 63, offset: 6504},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 232, col: 67, offset: 6508},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 232, col: 70, offset: 6511},
							label: "selectStmt",
							expr: &ruleRefExpr{
								pos:  position{line: 232, col: 81, offset: 6522},
								name: "SelectStmt",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 232, col: 92, offset: 6533},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 232, col: 95, offset: 6536},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SubQuerySelectItem",
			pos:  position{line: 241, col: 1, offset: 6748},
			expr: &actionExpr{
				pos: position{line: 241, col: 23, offset: 6770},
				run: (*parser).callonSubQuerySelectItem1,
				expr: &seqExpr{
					pos: position{line: 241, col: 23, offset: 6770},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 241, col: 23, offset: 6770},
							label: "subQuery",
							expr: &ruleRefExpr{
								pos:  position{line: 241, col: 32, offset: 6779},
								name: "SubQuery",
							},
						},
						&labeledExpr{
							pos:   position{line: 241, col: 41, offset: 6788},
							label: "asClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 241, col: 50, offset: 6797},
								expr: &actionExpr{
									pos: position{line: 241, col: 51, offset: 6798},
									run: (*parser).callonSubQuerySelectItem7,
									expr: &seqExpr{
										pos: position{line: 241, col: 51, offset: 6798},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 241, col: 51, offset: 6798},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 241, col: 54, offset: 6801},
												label: "alias",
												expr: &ruleRefExpr{
													pos:  position{line: 241, col: 60, offset: 6807},
													name: "AsClause",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "JoinClause",
			pos:  position{line: 254, col: 1, offset: 7092},
			expr: &choiceExpr{
				pos: position{line: 254, col: 15, offset: 7106},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 254, col: 15, offset: 7106},
						run: (*parser).callonJoinClause2,
						expr: &seqExpr{
							pos: position{line: 254, col: 15, offset: 7106},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 254, col: 15, offset: 7106},
									name: "Join",
								},
								&ruleRefExpr{
									pos:  position{line: 254, col: 20, offset: 7111},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 254, col: 23, offset: 7114},
									label: "table",
									expr: &ruleRefExpr{
										pos:  position{line: 254, col: 29, offset: 7120},
										name: "TableName",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 254, col: 39, offset: 7130},
									name: "ws",
								},
								&ruleRefExpr{
									pos:  position{line: 254, col: 42, offset: 7133},
									name: "In",
								},
								&ruleRefExpr{
									pos:  position{line: 254, col: 45, offset: 7136},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 254, col: 48, offset: 7139},
									label: "column",
									expr: &ruleRefExpr{
										pos:  position{line: 254, col: 55, offset: 7146},
										name: "SelectItem",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 256, col: 5, offset: 7198},
						run: (*parser).callonJoinClause13,
						expr: &seqExpr{
							pos: position{line: 256, col: 5, offset: 7198},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 256, col: 5, offset: 7198},
									name: "Join",
								},
								&ruleRefExpr{
									pos:  position{line: 256, col: 10, offset: 7203},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 256, col: 13, offset: 7206},
									label: "subQuery",
									expr: &ruleRefExpr{
										pos:  position{line: 256, col: 22, offset: 7215},
										name: "SubQuerySelectItem",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OffsetClause",
			pos:  position{line: 260, col: 1, offset: 7274},
			expr: &actionExpr{
				pos: position{line: 260, col: 17, offset: 7290},
				run: (*parser).callonOffsetClause1,
				expr: &seqExpr{
					pos: position{line: 260, col: 17, offset: 7290},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 260, col: 17, offset: 7290},
							name: "Offset",
						},
						&ruleRefExpr{
							pos:  position{line: 260, col: 24, offset: 7297},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 260, col: 27, offset: 7300},
							label: "offset",
							expr: &ruleRefExpr{
								pos:  position{line: 260, col: 34, offset: 7307},
								name: "IntegerLiteral",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 260, col: 49, offset: 7322},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 260, col: 52, offset: 7325},
							val:        "limit",
							ignoreCase: true,
							want:       "\"LIMIT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 260, col: 61, offset: 7334},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 260, col: 64, offset: 7337},
							label: "limit",
							expr: &ruleRefExpr{
								pos:  position{line: 260, col: 70, offset: 7343},
								name: "IntegerLiteral",
							},
						},
					},
				},
			},
		},
		{
			name: "Selection",
			pos:  position{line: 264, col: 1, offset: 7458},
			expr: &choiceExpr{
				pos: position{line: 264, col: 14, offset: 7471},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 264, col: 14, offset: 7471},
						name: "SelectValueSpec",
					},
					&ruleRefExpr{
						pos:  position{line: 264, col: 32, offset: 7489},
						name: "ColumnList",
					},
					&ruleRefExpr{
						pos:  position{line: 264, col: 45, offset: 7502},
						name: "SelectAsterisk",
					},
				},
			},
		},
		{
			name: "SelectAsterisk",
			pos:  position{line: 266, col: 1, offset: 7518},
			expr: &actionExpr{
				pos: position{line: 266, col: 19, offset: 7536},
				run: (*parser).callonSelectAsterisk1,
				expr: &litMatcher{
					pos:        position{line: 266, col: 19, offset: 7536},
					val:        "*",
					ignoreCase: false,
					want:       "\"*\"",
				},
			},
		},
		{
			name: "ColumnList",
			pos:  position{line: 272, col: 1, offset: 7731},
			expr: &actionExpr{
				pos: position{line: 272, col: 15, offset: 7745},
				run: (*parser).callonColumnList1,
				expr: &seqExpr{
					pos: position{line: 272, col: 15, offset: 7745},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 272, col: 15, offset: 7745},
							label: "column",
							expr: &ruleRefExpr{
								pos:  position{line: 272, col: 22, offset: 7752},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 272, col: 33, offset: 7763},
							label: "other_columns",
							expr: &zeroOrMoreExpr{
								pos: position{line: 272, col: 47, offset: 7777},
								expr: &actionExpr{
									pos: position{line: 272, col: 48, offset: 7778},
									run: (*parser).callonColumnList7,
									expr: &seqExpr{
										pos: position{line: 272, col: 48, offset: 7778},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 272, col: 48, offset: 7778},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 272, col: 51, offset: 7781},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 272, col: 55, offset: 7785},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 272, col: 58, offset: 7788},
												label: "coll",
												expr: &ruleRefExpr{
													pos:  position{line: 272, col: 63, offset: 7793},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SelectValueSpec",
			pos:  position{line: 276, col: 1, offset: 7880},
			expr: &actionExpr{
				pos: position{line: 276, col: 20, offset: 7899},
				run: (*parser).callonSelectValueSpec1,
				expr: &seqExpr{
					pos: position{line: 276, col: 20, offset: 7899},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 276, col: 20, offset: 7899},
							val:        "value",
							ignoreCase: true,
							want:       "\"VALUE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 276, col: 29, offset: 7908},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 276, col: 32, offset: 7911},
							label: "column",
							expr: &ruleRefExpr{
								pos:  position{line: 276, col: 39, offset: 7918},
								name: "SelectItem",
							},
						},
					},
				},
			},
		},
		{
			name: "TableName",
			pos:  position{line: 282, col: 1, offset: 8072},
			expr: &actionExpr{
				pos: position{line: 282, col: 14, offset: 8085},
				run: (*parser).callonTableName1,
				expr: &labeledExpr{
					pos:   position{line: 282, col: 14, offset: 8085},
					label: "key",
					expr: &ruleRefExpr{
						pos:  position{line: 282, col: 18, offset: 8089},
						name: "Identifier",
					},
				},
			},
		},
		{
			name: "SelectArray",
			pos:  position{line: 286, col: 1, offset: 8156},
			expr: &actionExpr{
				pos: position{line: 286, col: 16, offset: 8171},
				run: (*parser).callonSelectArray1,
				expr: &seqExpr{
					pos: position{line: 286, col: 16, offset: 8171},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 286, col: 16, offset: 8171},
							val:        "[",
							ignoreCase: false,
							want:       "\"[\"",
						},
						&ruleRefExpr{
							pos:  position{line: 286, col: 20, offset: 8175},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 286, col: 23, offset: 8178},
							label: "columns",
							expr: &ruleRefExpr{
								pos:  position{line: 286, col: 31, offset: 8186},
								name: "ColumnList",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 286, col: 42, offset: 8197},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 286, col: 45, offset: 8200},
							val:        "]",
							ignoreCase: false,
							want:       "\"]\"",
						},
					},
				},
			},
		},
		{
			name: "SelectObject",
			pos:  position{line: 290, col: 1, offset: 8245},
			expr: &choiceExpr{
				pos: position{line: 290, col: 17, offset: 8261},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 290, col: 17, offset: 8261},
						run: (*parser).callonSelectObject2,
						expr: &seqExpr{
							pos: position{line: 290, col: 17, offset: 8261},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 290, col: 17, offset: 8261},
									val:        "{",
									ignoreCase: false,
									want:       "\"{\"",
								},
								&ruleRefExpr{
									pos:  position{line: 290, col: 21, offset: 8265},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 290, col: 24, offset: 8268},
									label: "field",
									expr: &ruleRefExpr{
										pos:  position{line: 290, col: 30, offset: 8274},
										name: "SelectObjectField",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 290, col: 48, offset: 8292},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 290, col: 51, offset: 8295},
									label: "other_fields",
									expr: &zeroOrMoreExpr{
										pos: position{line: 290, col: 64, offset: 8308},
										expr: &actionExpr{
											pos: position{line: 290, col: 65, offset: 8309},
											run: (*parser).callonSelectObject11,
											expr: &seqExpr{
												pos: position{line: 290, col: 65, offset: 8309},
												exprs: []any{
													&ruleRefExpr{
														pos:  position{line: 290, col: 65, offset: 8309},
														name: "ws",
													},
													&litMatcher{
														pos:        position{line: 290, col: 68, offset: 8312},
														val:        ",",
														ignoreCase: false,
														want:       "\",\"",
													},
													&ruleRefExpr{
														pos:  position{line: 290, col: 72, offset: 8316},
														name: "ws",
													},
													&labeledExpr{
														pos:   position{line: 290, col: 75, offset: 8319},
														label: "coll",
														expr: &ruleRefExpr{
															pos:  position{line: 290, col: 80, offset: 8324},
															name: "SelectObjectField",
														},
													},
												},
											},
										},
									},
								},
								&ruleRefExpr{
									pos:  position{line: 290, col: 120, offset: 8364},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 290, col: 123, offset: 8367},
									val:        "}",
									ignoreCase: false,
									want:       "\"}\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 292, col: 5, offset: 8426},
						run: (*parser).callonSelectObject20,
						expr: &seqExpr{
							pos: position{line: 292, col: 5, offset: 8426},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 292, col: 5, offset: 8426},
									val:        "{",
									ignoreCase: false,
									want:       "\"{\"",
								},
								&ruleRefExpr{
									pos:  position{line: 292, col: 9, offset: 8430},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 292, col: 12, offset: 8433},
									val:        "}",
									ignoreCase: false,
									want:       "\"}\"",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SelectObjectField",
			pos:  position{line: 299, col: 1, offset: 8565},
			expr: &actionExpr{
				pos: position{line: 299, col: 22, offset: 8586},
				run: (*parser).callonSelectObjectField1,
				expr: &seqExpr{
					pos: position{line: 299, col: 22, offset: 8586},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 299, col: 22, offset: 8586},
							label: "name",
							expr: &choiceExpr{
								pos: position{line: 299, col: 28, offset: 8592},
								alternatives: []any{
									&ruleRefExpr{
										pos:  position{line: 299, col: 28, offset: 8592},
										name: "Identifier",
									},
									&actionExpr{
										pos: position{line: 299, col: 41, offset: 8605},
										run: (*parser).callonSelectObjectField6,
										expr: &seqExpr{
											pos: position{line: 299, col: 41, offset: 8605},
											exprs: []any{
												&litMatcher{
													pos:        position{line: 299, col: 41, offset: 8605},
													val:        "\"",
													ignoreCase: false,
													want:       "\"\\\"\"",
												},
												&labeledExpr{
													pos:   position{line: 299, col: 46, offset: 8610},
													label: "key",
													expr: &ruleRefExpr{
														pos:  position{line: 299, col: 50, offset: 8614},
														name: "Identifier",
													},
												},
												&litMatcher{
													pos:        position{line: 299, col: 61, offset: 8625},
													val:        "\"",
													ignoreCase: false,
													want:       "\"\\\"\"",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 299, col: 87, offset: 8651},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 299, col: 90, offset: 8654},
							val:        ":",
							ignoreCase: false,
							want:       "\":\"",
						},
						&ruleRefExpr{
							pos:  position{line: 299, col: 94, offset: 8658},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 299, col: 97, offset: 8661},
							label: "selectItem",
							expr: &ruleRefExpr{
								pos:  position{line: 299, col: 108, offset: 8672},
								name: "SelectItem",
							},
						},
					},
				},
			},
		},
		{
			name: "SelectProperty",
			pos:  position{line: 305, col: 1, offset: 8778},
			expr: &actionExpr{
				pos: position{line: 305, col: 19, offset: 8796},
				run: (*parser).callonSelectProperty1,
				expr: &seqExpr{
					pos: position{line: 305, col: 19, offset: 8796},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 305, col: 19, offset: 8796},
							label: "name",
							expr: &ruleRefExpr{
								pos:  position{line: 305, col: 24, offset: 8801},
								name: "Identifier",
							},
						},
						&labeledExpr{
							pos:   position{line: 305, col: 35, offset: 8812},
							label: "path",
							expr: &zeroOrMoreExpr{
								pos: position{line: 305, col: 40, offset: 8817},
								expr: &choiceExpr{
									pos: position{line: 305, col: 41, offset: 8818},
									alternatives: []any{
										&ruleRefExpr{
											pos:  position{line: 305, col: 41, offset: 8818},
											name: "DotFieldAccess",
										},
										&ruleRefExpr{
											pos:  position{line: 305, col: 58, offset: 8835},
											name: "ArrayFieldAccess",
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SelectItem",
			pos:  position{line: 309, col: 1, offset: 8926},
			expr: &actionExpr{
				pos: position{line: 309, col: 15, offset: 8940},
				run: (*parser).callonSelectItem1,
				expr: &seqExpr{
					pos: position{line: 309, col: 15, offset: 8940},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 309, col: 15, offset: 8940},
							label: "selectItem",
							expr: &choiceExpr{
								pos: position{line: 309, col: 27, offset: 8952},
								alternatives: []any{
									&ruleRefExpr{
										pos:  position{line: 309, col: 27, offset: 8952},
										name: "SubQuerySelectItem",
									},
									&ruleRefExpr{
										pos:  position{line: 309, col: 48, offset: 8973},
										name: "Literal",
									},
									&ruleRefExpr{
										pos:  position{line: 309, col: 58, offset: 8983},
										name: "FunctionCall",
									},
									&ruleRefExpr{
										pos:  position{line: 309, col: 73, offset: 8998},
										name: "SelectArray",
									},
									&ruleRefExpr{
										pos:  position{line: 309, col: 87, offset: 9012},
										name: "SelectObject",
									},
									&ruleRefExpr{
										pos:  position{line: 309, col: 102, offset: 9027},
										name: "SelectProperty",
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 309, col: 118, offset: 9043},
							label: "asClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 309, col: 127, offset: 9052},
								expr: &ruleRefExpr{
									pos:  position{line: 309, col: 127, offset: 9052},
									name: "AsClause",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "AsClause",
			pos:  position{line: 333, col: 1, offset: 9650},
			expr: &actionExpr{
				pos: position{line: 333, col: 13, offset: 9662},
				run: (*parser).callonAsClause1,
				expr: &seqExpr{
					pos: position{line: 333, col: 13, offset: 9662},
					exprs: []any{
						&zeroOrOneExpr{
							pos: position{line: 333, col: 13, offset: 9662},
							expr: &seqExpr{
								pos: position{line: 333, col: 14, offset: 9663},
								exprs: []any{
									&ruleRefExpr{
										pos:  position{line: 333, col: 14, offset: 9663},
										name: "ws",
									},
									&ruleRefExpr{
										pos:  position{line: 333, col: 17, offset: 9666},
										name: "As",
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 333, col: 22, offset: 9671},
							name: "ws",
						},
						&notExpr{
							pos: position{line: 333, col: 25, offset: 9674},
							expr: &ruleRefExpr{
								pos:  position{line: 333, col: 26, offset: 9675},
								name: "ExcludedKeywords",
							},
						},
						&labeledExpr{
							pos:   position{line: 333, col: 43, offset: 9692},
							label: "alias",
							expr: &ruleRefExpr{
								pos:  position{line: 333, col: 49, offset: 9698},
								name: "Identifier",
							},
						},
					},
				},
			},
		},
		{
			name: "ExcludedKeywords",
			pos:  position{line: 337, col: 1, offset: 9736},
			expr: &choiceExpr{
				pos: position{line: 337, col: 21, offset: 9756},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 337, col: 21, offset: 9756},
						name: "Select",
					},
					&ruleRefExpr{
						pos:  position{line: 337, col: 30, offset: 9765},
						name: "Top",
					},
					&ruleRefExpr{
						pos:  position{line: 337, col: 36, offset: 9771},
						name: "As",
					},
					&ruleRefExpr{
						pos:  position{line: 337, col: 41, offset: 9776},
						name: "From",
					},
					&ruleRefExpr{
						pos:  position{line: 337, col: 48, offset: 9783},
						name: "In",
					},
					&ruleRefExpr{
						pos:  position{line: 337, col: 53, offset: 9788},
						name: "Join",
					},
					&ruleRefExpr{
						pos:  position{line: 337, col: 60, offset: 9795},
						name: "Exists",
					},
					&ruleRefExpr{
						pos:  position{line: 337, col: 69, offset: 9804},
						name: "Where",
					},
					&ruleRefExpr{
						pos:  position{line: 337, col: 77, offset: 9812},
						name: "And",
					},
					&ruleRefExpr{
						pos:  position{line: 337, col: 83, offset: 9818},
						name: "Or",
					},
					&ruleRefExpr{
						pos:  position{line: 337, col: 88, offset: 9823},
						name: "Not",
					},
					&ruleRefExpr{
						pos:  position{line: 337, col: 94, offset: 9829},
						name: "GroupBy",
					},
					&ruleRefExpr{
						pos:  position{line: 337, col: 104, offset: 9839},
						name: "OrderBy",
					},
					&ruleRefExpr{
						pos:  position{line: 337, col: 114, offset: 9849},
						name: "Offset",
					},
				},
			},
		},
		{
			name: "DotFieldAccess",
			pos:  position{line: 339, col: 1, offset: 9857},
			expr: &actionExpr{
				pos: position{line: 339, col: 19, offset: 9875},
				run: (*parser).callonDotFieldAccess1,
				expr: &seqExpr{
					pos: position{line: 339, col: 19, offset: 9875},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 339, col: 19, offset: 9875},
							val:        ".",
							ignoreCase: false,
							want:       "\".\"",
						},
						&labeledExpr{
							pos:   position{line: 339, col: 23, offset: 9879},
							label: "id",
							expr: &ruleRefExpr{
								pos:  position{line: 339, col: 26, offset: 9882},
								name: "Identifier",
							},
						},
					},
				},
			},
		},
		{
			name: "ArrayFieldAccess",
			pos:  position{line: 343, col: 1, offset: 9917},
			expr: &choiceExpr{
				pos: position{line: 343, col: 21, offset: 9937},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 343, col: 21, offset: 9937},
						run: (*parser).callonArrayFieldAccess2,
						expr: &seqExpr{
							pos: position{line: 343, col: 21, offset: 9937},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 343, col: 21, offset: 9937},
									val:        "[\"",
									ignoreCase: false,
									want:       "\"[\\\"\"",
								},
								&labeledExpr{
									pos:   position{line: 343, col: 27, offset: 9943},
									label: "id",
									expr: &ruleRefExpr{
										pos:  position{line: 343, col: 30, offset: 9946},
										name: "Identifier",
									},
								},
								&litMatcher{
									pos:        position{line: 343, col: 41, offset: 9957},
									val:        "\"]",
									ignoreCase: false,
									want:       "\"\\\"]\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 344, col: 5, offset: 9986},
						run: (*parser).callonArrayFieldAccess8,
						expr: &seqExpr{
							pos: position{line: 344, col: 5, offset: 9986},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 344, col: 5, offset: 9986},
									val:        "[",
									ignoreCase: false,
									want:       "\"[\"",
								},
								&labeledExpr{
									pos:   position{line: 344, col: 9, offset: 9990},
									label: "id",
									expr: &ruleRefExpr{
										pos:  position{line: 344, col: 12, offset: 9993},
										name: "Integer",
									},
								},
								&litMatcher{
									pos:        position{line: 344, col: 20, offset: 10001},
									val:        "]",
									ignoreCase: false,
									want:       "\"]\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 345, col: 5, offset: 10048},
						run: (*parser).callonArrayFieldAccess14,
						expr: &seqExpr{
							pos: position{line: 345, col: 5, offset: 10048},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 345, col: 5, offset: 10048},
									val:        "[",
									ignoreCase: false,
									want:       "\"[\"",
								},
								&labeledExpr{
									pos:   position{line: 345, col: 9, offset: 10052},
									label: "id",
									expr: &ruleRefExpr{
										pos:  position{line: 345, col: 12, offset: 10055},
										name: "ParameterConstant",
									},
								},
								&litMatcher{
									pos:        position{line: 345, col: 30, offset: 10073},
									val:        "]",
									ignoreCase: false,
									want:       "\"]\"",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "Identifier",
			pos:  position{line: 347, col: 1, offset: 10131},
			expr: &actionExpr{
				pos: position{line: 347, col: 15, offset: 10145},
				run: (*parser).callonIdentifier1,
				expr: &seqExpr{
					pos: position{line: 347, col: 15, offset: 10145},
					exprs: []any{
						&charClassMatcher{
							pos:        position{line: 347, col: 15, offset: 10145},
							val:        "[a-zA-Z_]",
							chars:      []rune{'_'},
							ranges:     []rune{'a', 'z', 'A', 'Z'},
							ignoreCase: false,
							inverted:   false,
						},
						&zeroOrMoreExpr{
							pos: position{line: 347, col: 24, offset: 10154},
							expr: &charClassMatcher{
								pos:        position{line: 347, col: 24, offset: 10154},
								val:        "[a-zA-Z0-9_]",
								chars:      []rune{'_'},
								ranges:     []rune{'a', 'z', 'A', 'Z', '0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
					},
				},
			},
		},
		{
			name: "Condition",
			pos:  position{line: 351, col: 1, offset: 10204},
			expr: &actionExpr{
				pos: position{line: 351, col: 14, offset: 10217},
				run: (*parser).callonCondition1,
				expr: &labeledExpr{
					pos:   position{line: 351, col: 14, offset: 10217},
					label: "expression",
					expr: &ruleRefExpr{
						pos:  position{line: 351, col: 25, offset: 10228},
						name: "OrExpression",
					},
				},
			},
		},
		{
			name: "OrExpression",
			pos:  position{line: 355, col: 1, offset: 10273},
			expr: &actionExpr{
				pos: position{line: 355, col: 17, offset: 10289},
				run: (*parser).callonOrExpression1,
				expr: &seqExpr{
					pos: position{line: 355, col: 17, offset: 10289},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 355, col: 17, offset: 10289},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 355, col: 21, offset: 10293},
								name: "AndExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 355, col: 35, offset: 10307},
							label: "ex2",
							expr: &zeroOrMoreExpr{
								pos: position{line: 355, col: 39, offset: 10311},
								expr: &actionExpr{
									pos: position{line: 355, col: 40, offset: 10312},
									run: (*parser).callonOrExpression7,
									expr: &seqExpr{
										pos: position{line: 355, col: 40, offset: 10312},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 355, col: 40, offset: 10312},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 355, col: 43, offset: 10315},
												name: "Or",
											},
											&ruleRefExpr{
												pos:  position{line: 355, col: 46, offset: 10318},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 355, col: 49, offset: 10321},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 355, col: 52, offset: 10324},
													name: "AndExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "AndExpression",
			pos:  position{line: 359, col: 1, offset: 10437},
			expr: &actionExpr{
				pos: position{line: 359, col: 18, offset: 10454},
				run: (*parser).callonAndExpression1,
				expr: &seqExpr{
					pos: position{line: 359, col: 18, offset: 10454},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 359, col: 18, offset: 10454},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 359, col: 22, offset: 10458},
								name: "ComparisonExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 359, col: 43, offset: 10479},
							label: "ex2",
							expr: &zeroOrMoreExpr{
								pos: position{line: 359, col: 47, offset: 10483},
								expr: &actionExpr{
									pos: position{line: 359, col: 48, offset: 10484},
									run: (*parser).callonAndExpression7,
									expr: &seqExpr{
										pos: position{line: 359, col: 48, offset: 10484},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 359, col: 48, offset: 10484},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 359, col: 51, offset: 10487},
												name: "And",
											},
											&ruleRefExpr{
												pos:  position{line: 359, col: 55, offset: 10491},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 359, col: 58, offset: 10494},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 359, col: 61, offset: 10497},
													name: "ComparisonExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "ComparisonExpression",
			pos:  position{line: 363, col: 1, offset: 10618},
			expr: &choiceExpr{
				pos: position{line: 363, col: 25, offset: 10642},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 363, col: 25, offset: 10642},
						run: (*parser).callonComparisonExpression2,
						expr: &seqExpr{
							pos: position{line: 363, col: 25, offset: 10642},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 363, col: 25, offset: 10642},
									val:        "(",
									ignoreCase: false,
									want:       "\"(\"",
								},
								&ruleRefExpr{
									pos:  position{line: 363, col: 29, offset: 10646},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 363, col: 32, offset: 10649},
									label: "ex",
									expr: &ruleRefExpr{
										pos:  position{line: 363, col: 35, offset: 10652},
										name: "OrExpression",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 363, col: 48, offset: 10665},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 363, col: 51, offset: 10668},
									val:        ")",
									ignoreCase: false,
									want:       "\")\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 364, col: 7, offset: 10697},
						run: (*parser).callonComparisonExpression10,
						expr: &seqExpr{
							pos: position{line: 364, col: 7, offset: 10697},
							exprs: []any{
								&labeledExpr{
									pos:   position{line: 364, col: 7, offset: 10697},
									label: "left",
									expr: &ruleRefExpr{
										pos:  position{line: 364, col: 12, offset: 10702},
										name: "SelectItem",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 364, col: 23, offset: 10713},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 364, col: 26, offset: 10716},
									label: "op",
									expr: &ruleRefExpr{
										pos:  position{line: 364, col: 29, offset: 10719},
										name: "ComparisonOperator",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 364, col: 48, offset: 10738},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 364, col: 51, offset: 10741},
									label: "right",
									expr: &ruleRefExpr{
										pos:  position{line: 364, col: 57, offset: 10747},
										name: "SelectItem",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 366, col: 5, offset: 10854},
						run: (*parser).callonComparisonExpression20,
						expr: &seqExpr{
							pos: position{line: 366, col: 5, offset: 10854},
							exprs: []any{
								&labeledExpr{
									pos:   position{line: 366, col: 5, offset: 10854},
									label: "inv",
									expr: &zeroOrOneExpr{
										pos: position{line: 366, col: 9, offset: 10858},
										expr: &seqExpr{
											pos: position{line: 366, col: 10, offset: 10859},
											exprs: []any{
												&ruleRefExpr{
													pos:  position{line: 366, col: 10, offset: 10859},
													name: "Not",
												},
												&ruleRefExpr{
													pos:  position{line: 366, col: 14, offset: 10863},
													name: "ws",
												},
											},
										},
									},
								},
								&labeledExpr{
									pos:   position{line: 366, col: 19, offset: 10868},
									label: "ex",
									expr: &ruleRefExpr{
										pos:  position{line: 366, col: 22, offset: 10871},
										name: "SelectItem",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 373, col: 5, offset: 11001},
						run: (*parser).callonComparisonExpression29,
						expr: &labeledExpr{
							pos:   position{line: 373, col: 5, offset: 11001},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 373, col: 8, offset: 11004},
								name: "BooleanLiteral",
							},
						},
					},
				},
			},
		},
		{
			name: "OrderByClause",
			pos:  position{line: 375, col: 1, offset: 11039},
			expr: &actionExpr{
				pos: position{line: 375, col: 18, offset: 11056},
				run: (*parser).callonOrderByClause1,
				expr: &seqExpr{
					pos: position{line: 375, col: 18, offset: 11056},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 375, col: 18, offset: 11056},
							name: "OrderBy",
						},
						&ruleRefExpr{
							pos:  position{line: 375, col: 26, offset: 11064},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 375, col: 29, offset: 11067},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 375, col: 33, offset: 11071},
								name: "OrderExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 375, col: 49, offset: 11087},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 375, col: 56, offset: 11094},
								expr: &actionExpr{
									pos: position{line: 375, col: 57, offset: 11095},
									run: (*parser).callonOrderByClause9,
									expr: &seqExpr{
										pos: position{line: 375, col: 57, offset: 11095},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 375, col: 57, offset: 11095},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 375, col: 60, offset: 11098},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 375, col: 64, offset: 11102},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 375, col: 67, offset: 11105},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 375, col: 70, offset: 11108},
													name: "OrderExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OrderExpression",
			pos:  position{line: 379, col: 1, offset: 11192},
			expr: &actionExpr{
				pos: position{line: 379, col: 20, offset: 11211},
				run: (*parser).callonOrderExpression1,
				expr: &seqExpr{
					pos: position{line: 379, col: 20, offset: 11211},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 379, col: 20, offset: 11211},
							label: "field",
							expr: &ruleRefExpr{
								pos:  position{line: 379, col: 26, offset: 11217},
								name: "SelectProperty",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 379, col: 41, offset: 11232},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 379, col: 44, offset: 11235},
							label: "order",
							expr: &zeroOrOneExpr{
								pos: position{line: 379, col: 50, offset: 11241},
								expr: &ruleRefExpr{
									pos:  position{line: 379, col: 50, offset: 11241},
									name: "OrderDirection",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OrderDirection",
			pos:  position{line: 383, col: 1, offset: 11307},
			expr: &actionExpr{
				pos: position{line: 383, col: 19, offset: 11325},
				run: (*parser).callonOrderDirection1,
				expr: &choiceExpr{
					pos: position{line: 383, col: 20, offset: 11326},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 383, col: 20, offset: 11326},
							val:        "asc",
							ignoreCase: true,
							want:       "\"ASC\"i",
						},
						&litMatcher{
							pos:        position{line: 383, col: 29, offset: 11335},
							val:        "desc",
							ignoreCase: true,
							want:       "\"DESC\"i",
						},
					},
				},
			},
		},
		{
			name: "Select",
			pos:  position{line: 391, col: 1, offset: 11487},
			expr: &litMatcher{
				pos:        position{line: 391, col: 11, offset: 11497},
				val:        "select",
				ignoreCase: true,
				want:       "\"SELECT\"i",
			},
		},
		{
			name: "Top",
			pos:  position{line: 393, col: 1, offset: 11508},
			expr: &litMatcher{
				pos:        position{line: 393, col: 8, offset: 11515},
				val:        "top",
				ignoreCase: true,
				want:       "\"TOP\"i",
			},
		},
		{
			name: "As",
			pos:  position{line: 395, col: 1, offset: 11523},
			expr: &litMatcher{
				pos:        position{line: 395, col: 7, offset: 11529},
				val:        "as",
				ignoreCase: true,
				want:       "\"AS\"i",
			},
		},
		{
			name: "From",
			pos:  position{line: 397, col: 1, offset: 11536},
			expr: &litMatcher{
				pos:        position{line: 397, col: 9, offset: 11544},
				val:        "from",
				ignoreCase: true,
				want:       "\"FROM\"i",
			},
		},
		{
			name: "In",
			pos:  position{line: 399, col: 1, offset: 11553},
			expr: &litMatcher{
				pos:        position{line: 399, col: 7, offset: 11559},
				val:        "in",
				ignoreCase: true,
				want:       "\"IN\"i",
			},
		},
		{
			name: "Join",
			pos:  position{line: 401, col: 1, offset: 11566},
			expr: &litMatcher{
				pos:        position{line: 401, col: 9, offset: 11574},
				val:        "join",
				ignoreCase: true,
				want:       "\"JOIN\"i",
			},
		},
		{
			name: "Exists",
			pos:  position{line: 403, col: 1, offset: 11583},
			expr: &litMatcher{
				pos:        position{line: 403, col: 11, offset: 11593},
				val:        "exists",
				ignoreCase: true,
				want:       "\"EXISTS\"i",
			},
		},
		{
			name: "Where",
			pos:  position{line: 405, col: 1, offset: 11604},
			expr: &litMatcher{
				pos:        position{line: 405, col: 10, offset: 11613},
				val:        "where",
				ignoreCase: true,
				want:       "\"WHERE\"i",
			},
		},
		{
			name: "And",
			pos:  position{line: 407, col: 1, offset: 11623},
			expr: &litMatcher{
				pos:        position{line: 407, col: 8, offset: 11630},
				val:        "and",
				ignoreCase: true,
				want:       "\"AND\"i",
			},
		},
		{
			name: "Or",
			pos:  position{line: 409, col: 1, offset: 11638},
			expr: &seqExpr{
				pos: position{line: 409, col: 7, offset: 11644},
				exprs: []any{
					&litMatcher{
						pos:        position{line: 409, col: 7, offset: 11644},
						val:        "or",
						ignoreCase: true,
						want:       "\"OR\"i",
					},
					&ruleRefExpr{
						pos:  position{line: 409, col: 13, offset: 11650},
						name: "wss",
					},
				},
			},
		},
		{
			name: "Not",
			pos:  position{line: 411, col: 1, offset: 11655},
			expr: &litMatcher{
				pos:        position{line: 411, col: 8, offset: 11662},
				val:        "not",
				ignoreCase: true,
				want:       "\"NOT\"i",
			},
		},
		{
			name: "GroupBy",
			pos:  position{line: 413, col: 1, offset: 11670},
			expr: &seqExpr{
				pos: position{line: 413, col: 12, offset: 11681},
				exprs: []any{
					&litMatcher{
						pos:        position{line: 413, col: 12, offset: 11681},
						val:        "group",
						ignoreCase: true,
						want:       "\"GROUP\"i",
					},
					&ruleRefExpr{
						pos:  position{line: 413, col: 21, offset: 11690},
						name: "ws",
					},
					&litMatcher{
						pos:        position{line: 413, col: 24, offset: 11693},
						val:        "by",
						ignoreCase: true,
						want:       "\"BY\"i",
					},
				},
			},
		},
		{
			name: "OrderBy",
			pos:  position{line: 415, col: 1, offset: 11700},
			expr: &seqExpr{
				pos: position{line: 415, col: 12, offset: 11711},
				exprs: []any{
					&litMatcher{
						pos:        position{line: 415, col: 12, offset: 11711},
						val:        "order",
						ignoreCase: true,
						want:       "\"ORDER\"i",
					},
					&ruleRefExpr{
						pos:  position{line: 415, col: 21, offset: 11720},
						name: "ws",
					},
					&litMatcher{
						pos:        position{line: 415, col: 24, offset: 11723},
						val:        "by",
						ignoreCase: true,
						want:       "\"BY\"i",
					},
				},
			},
		},
		{
			name: "Offset",
			pos:  position{line: 417, col: 1, offset: 11730},
			expr: &litMatcher{
				pos:        position{line: 417, col: 11, offset: 11740},
				val:        "offset",
				ignoreCase: true,
				want:       "\"OFFSET\"i",
			},
		},
		{
			name: "ComparisonOperator",
			pos:  position{line: 419, col: 1, offset: 11751},
			expr: &actionExpr{
				pos: position{line: 419, col: 23, offset: 11773},
				run: (*parser).callonComparisonOperator1,
				expr: &choiceExpr{
					pos: position{line: 419, col: 24, offset: 11774},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 419, col: 24, offset: 11774},
							val:        "<=",
							ignoreCase: false,
							want:       "\"<=\"",
						},
						&litMatcher{
							pos:        position{line: 419, col: 31, offset: 11781},
							val:        ">=",
							ignoreCase: false,
							want:       "\">=\"",
						},
						&litMatcher{
							pos:        position{line: 419, col: 38, offset: 11788},
							val:        "=",
							ignoreCase: false,
							want:       "\"=\"",
						},
						&litMatcher{
							pos:        position{line: 419, col: 44, offset: 11794},
							val:        "!=",
							ignoreCase: false,
							want:       "\"!=\"",
						},
						&litMatcher{
							pos:        position{line: 419, col: 51, offset: 11801},
							val:        "<",
							ignoreCase: false,
							want:       "\"<\"",
						},
						&litMatcher{
							pos:        position{line: 419, col: 57, offset: 11807},
							val:        ">",
							ignoreCase: false,
							want:       "\">\"",
						},
					},
				},
			},
		},
		{
			name: "Literal",
			pos:  position{line: 423, col: 1, offset: 11848},
			expr: &choiceExpr{
				pos: position{line: 423, col: 12, offset: 11859},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 423, col: 12, offset: 11859},
						name: "FloatLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 423, col: 27, offset: 11874},
						name: "IntegerLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 423, col: 44, offset: 11891},
						name: "StringLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 423, col: 60, offset: 11907},
						name: "BooleanLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 423, col: 77, offset: 11924},
						name: "ParameterConstant",
					},
					&ruleRefExpr{
						pos:  position{line: 423, col: 97, offset: 11944},
						name: "NullConstant",
					},
				},
			},
		},
		{
			name: "ParameterConstant",
			pos:  position{line: 425, col: 1, offset: 11958},
			expr: &actionExpr{
				pos: position{line: 425, col: 22, offset: 11979},
				run: (*parser).callonParameterConstant1,
				expr: &seqExpr{
					pos: position{line: 425, col: 22, offset: 11979},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 425, col: 22, offset: 11979},
							val:        "@",
							ignoreCase: false,
							want:       "\"@\"",
						},
						&ruleRefExpr{
							pos:  position{line: 425, col: 26, offset: 11983},
							name: "Identifier",
						},
					},
				},
			},
		},
		{
			name: "NullConstant",
			pos:  position{line: 428, col: 1, offset: 12099},
			expr: &actionExpr{
				pos: position{line: 428, col: 17, offset: 12115},
				run: (*parser).callonNullConstant1,
				expr: &litMatcher{
					pos:        position{line: 428, col: 17, offset: 12115},
					val:        "null",
					ignoreCase: true,
					want:       "\"null\"i",
				},
			},
		},
		{
			name: "IntegerLiteral",
			pos:  position{line: 432, col: 1, offset: 12173},
			expr: &actionExpr{
				pos: position{line: 432, col: 19, offset: 12191},
				run: (*parser).callonIntegerLiteral1,
				expr: &labeledExpr{
					pos:   position{line: 432, col: 19, offset: 12191},
					label: "number",
					expr: &ruleRefExpr{
						pos:  position{line: 432, col: 26, offset: 12198},
						name: "Integer",
					},
				},
			},
		},
		{
			name: "StringLiteral",
			pos:  position{line: 435, col: 1, offset: 12299},
			expr: &actionExpr{
				pos: position{line: 435, col: 18, offset: 12316},
				run: (*parser).callonStringLiteral1,
				expr: &seqExpr{
					pos: position{line: 435, col: 18, offset: 12316},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 435, col: 18, offset: 12316},
							val:        "\"",
							ignoreCase: false,
							want:       "\"\\\"\"",
						},
						&labeledExpr{
							pos:   position{line: 435, col: 23, offset: 12321},
							label: "chars",
							expr: &zeroOrMoreExpr{
								pos: position{line: 435, col: 29, offset: 12327},
								expr: &ruleRefExpr{
									pos:  position{line: 435, col: 29, offset: 12327},
									name: "StringCharacter",
								},
							},
						},
						&litMatcher{
							pos:        position{line: 435, col: 46, offset: 12344},
							val:        "\"",
							ignoreCase: false,
							want:       "\"\\\"\"",
						},
					},
				},
			},
		},
		{
			name: "FloatLiteral",
			pos:  position{line: 438, col: 1, offset: 12462},
			expr: &actionExpr{
				pos: position{line: 438, col: 17, offset: 12478},
				run: (*parser).callonFloatLiteral1,
				expr: &seqExpr{
					pos: position{line: 438, col: 17, offset: 12478},
					exprs: []any{
						&oneOrMoreExpr{
							pos: position{line: 438, col: 17, offset: 12478},
							expr: &charClassMatcher{
								pos:        position{line: 438, col: 17, offset: 12478},
								val:        "[0-9]",
								ranges:     []rune{'0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
						&litMatcher{
							pos:        position{line: 438, col: 23, offset: 12484},
							val:        ".",
							ignoreCase: false,
							want:       "\".\"",
						},
						&oneOrMoreExpr{
							pos: position{line: 438, col: 26, offset: 12487},
							expr: &charClassMatcher{
								pos:        position{line: 438, col: 26, offset: 12487},
								val:        "[0-9]",
								ranges:     []rune{'0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
					},
				},
			},
		},
		{
			name: "BooleanLiteral",
			pos:  position{line: 442, col: 1, offset: 12643},
			expr: &actionExpr{
				pos: position{line: 442, col: 19, offset: 12661},
				run: (*parser).callonBooleanLiteral1,
				expr: &choiceExpr{
					pos: position{line: 442, col: 20, offset: 12662},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 442, col: 20, offset: 12662},
							val:        "true",
							ignoreCase: true,
							want:       "\"true\"i",
						},
						&litMatcher{
							pos:        position{line: 442, col: 30, offset: 12672},
							val:        "false",
							ignoreCase: true,
							want:       "\"false\"i",
						},
					},
				},
			},
		},
		{
			name: "FunctionCall",
			pos:  position{line: 447, col: 1, offset: 12827},
			expr: &choiceExpr{
				pos: position{line: 447, col: 17, offset: 12843},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 447, col: 17, offset: 12843},
						name: "StringFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 448, col: 7, offset: 12865},
						name: "TypeCheckingFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 449, col: 7, offset: 12893},
						name: "ArrayFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 450, col: 7, offset: 12914},
						name: "ConditionalFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 451, col: 7, offset: 12941},
						name: "InFunction",
					},
					&ruleRefExpr{
						pos:  position{line: 452, col: 7, offset: 12958},
						name: "AggregateFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 453, col: 7, offset: 12983},
						name: "MathFunctions",
					},
				},
			},
		},
		{
			name: "StringFunctions",
			pos:  position{line: 455, col: 1, offset: 12998},
			expr: &choiceExpr{
				pos: position{line: 455, col: 20, offset: 13017},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 455, col: 20, offset: 13017},
						name: "StringEqualsExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 456, col: 7, offset: 13046},
						name: "ToStringExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 457, col: 7, offset: 13071},
						name: "ConcatExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 458, col: 7, offset: 13094},
						name: "ThreeArgumentStringFunctionExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 459, col: 7, offset: 13138},
						name: "UpperExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 460, col: 7, offset: 13160},
						name: "LowerExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 461, col: 7, offset: 13182},
						name: "LeftExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 462, col: 7, offset: 13203},
						name: "LengthExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 463, col: 7, offset: 13226},
						name: "LTrimExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 464, col: 7, offset: 13248},
						name: "ReplaceExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 465, col: 7, offset: 13272},
						name: "ReplicateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 466, col: 7, offset: 13298},
						name: "ReverseExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 467, col: 7, offset: 13322},
						name: "RightExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 468, col: 7, offset: 13344},
						name: "RTrimExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 469, col: 7, offset: 13366},
						name: "SubstringExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 470, col: 7, offset: 13392},
						name: "TrimExpression",
					},
				},
			},
		},
		{
			name: "TypeCheckingFunctions",
			pos:  position{line: 472, col: 1, offset: 13408},
			expr: &choiceExpr{
				pos: position{line: 472, col: 26, offset: 13433},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 472, col: 26, offset: 13433},
						name: "IsDefined",
					},
					&ruleRefExpr{
						pos:  position{line: 473, col: 7, offset: 13449},
						name: "IsArray",
					},
					&ruleRefExpr{
						pos:  position{line: 474, col: 7, offset: 13463},
						name: "IsBool",
					},
					&ruleRefExpr{
						pos:  position{line: 475, col: 7, offset: 13476},
						name: "IsFiniteNumber",
					},
					&ruleRefExpr{
						pos:  position{line: 476, col: 7, offset: 13497},
						name: "IsInteger",
					},
					&ruleRefExpr{
						pos:  position{line: 477, col: 7, offset: 13513},
						name: "IsNull",
					},
					&ruleRefExpr{
						pos:  position{line: 478, col: 7, offset: 13526},
						name: "IsNumber",
					},
					&ruleRefExpr{
						pos:  position{line: 479, col: 7, offset: 13541},
						name: "IsObject",
					},
					&ruleRefExpr{
						pos:  position{line: 480, col: 7, offset: 13556},
						name: "IsPrimitive",
					},
					&ruleRefExpr{
						pos:  position{line: 481, col: 7, offset: 13574},
						name: "IsString",
					},
				},
			},
		},
		{
			name: "AggregateFunctions",
			pos:  position{line: 483, col: 1, offset: 13584},
			expr: &choiceExpr{
				pos: position{line: 483, col: 23, offset: 13606},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 483, col: 23, offset: 13606},
						name: "AvgAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 484, col: 7, offset: 13635},
						name: "CountAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 485, col: 7, offset: 13666},
						name: "MaxAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 486, col: 7, offset: 13695},
						name: "MinAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 487, col: 7, offset: 13724},
						name: "SumAggregateExpression",
					},
				},
			},
		},
		{
			name: "ArrayFunctions",
			pos:  position{line: 489, col: 1, offset: 13748},
			expr: &choiceExpr{
				pos: position{line: 489, col: 19, offset: 13766},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 489, col: 19, offset: 13766},
						name: "ArrayConcatExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 490, col: 7, offset: 13794},
						name: "ArrayContainsExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 491, col: 7, offset: 13824},
						name: "ArrayContainsAnyExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 492, col: 7, offset: 13857},
						name: "ArrayContainsAllExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 493, col: 7, offset: 13890},
						name: "ArrayLengthExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 494, col: 7, offset: 13918},
						name: "ArraySliceExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 495, col: 7, offset: 13945},
						name: "SetIntersectExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 496, col: 7, offset: 13974},
						name: "SetUnionExpression",
					},
				},
			},
		},
		{
			name: "ConditionalFunctions",
			pos:  position{line: 498, col: 1, offset: 13994},
			expr: &ruleRefExpr{
				pos:  position{line: 498, col: 25, offset: 14018},
				name: "IifExpression",
			},
		},
		{
			name: "MathFunctions",
			pos:  position{line: 500, col: 1, offset: 14033},
			expr: &choiceExpr{
				pos: position{line: 500, col: 18, offset: 14050},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 500, col: 18, offset: 14050},
						name: "MathAbsExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 501, col: 7, offset: 14074},
						name: "MathAcosExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 502, col: 7, offset: 14099},
						name: "MathAsinExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 503, col: 7, offset: 14124},
						name: "MathAtanExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 504, col: 7, offset: 14149},
						name: "MathCeilingExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 505, col: 7, offset: 14177},
						name: "MathCosExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 506, col: 7, offset: 14201},
						name: "MathCotExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 507, col: 7, offset: 14225},
						name: "MathDegreesExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 508, col: 7, offset: 14253},
						name: "MathExpExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 509, col: 7, offset: 14277},
						name: "MathFloorExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 510, col: 7, offset: 14303},
						name: "MathIntBitNotExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 511, col: 7, offset: 14333},
						name: "MathLog10Expression",
					},
					&ruleRefExpr{
						pos:  position{line: 512, col: 7, offset: 14359},
						name: "MathRadiansExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 513, col: 7, offset: 14387},
						name: "MathRoundExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 514, col: 7, offset: 14413},
						name: "MathSignExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 515, col: 7, offset: 14438},
						name: "MathSinExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 516, col: 7, offset: 14462},
						name: "MathSqrtExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 517, col: 7, offset: 14487},
						name: "MathSquareExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 518, col: 7, offset: 14514},
						name: "MathTanExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 519, col: 7, offset: 14538},
						name: "MathTruncExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 520, col: 7, offset: 14564},
						name: "MathAtn2Expression",
					},
					&ruleRefExpr{
						pos:  position{line: 521, col: 7, offset: 14589},
						name: "MathIntAddExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 522, col: 7, offset: 14616},
						name: "MathIntBitAndExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 523, col: 7, offset: 14646},
						name: "MathIntBitLeftShiftExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 524, col: 7, offset: 14682},
						name: "MathIntBitOrExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 525, col: 7, offset: 14711},
						name: "MathIntBitRightShiftExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 526, col: 7, offset: 14748},
						name: "MathIntBitXorExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 527, col: 7, offset: 14778},
						name: "MathIntDivExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 528, col: 7, offset: 14805},
						name: "MathIntModExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 529, col: 7, offset: 14832},
						name: "MathIntMulExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 530, col: 7, offset: 14859},
						name: "MathIntSubExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 531, col: 7, offset: 14886},
						name: "MathPowerExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 532, col: 7, offset: 14912},
						name: "MathLogExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 533, col: 7, offset: 14936},
						name: "MathNumberBinExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 534, col: 7, offset: 14966},
						name: "MathPiExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 535, col: 7, offset: 14989},
						name: "MathRandExpression",
					},
				},
			},
		},
		{
			name: "UpperExpression",
			pos:  position{line: 537, col: 1, offset: 15009},
			expr: &actionExpr{
				pos: position{line: 537, col: 20, offset: 15028},
				run: (*parser).callonUpperExpression1,
				expr: &seqExpr{
					pos: position{line: 537, col: 20, offset: 15028},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 537, col: 20, offset: 15028},
							val:        "upper",
							ignoreCase: true,
							want:       "\"UPPER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 537, col: 29, offset: 15037},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 537, col: 32, offset: 15040},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&labeledExpr{
							pos:   position{line: 537, col: 36, offset: 15044},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 537, col: 39, offset: 15047},
								name: "SelectItem",
							},
						},
						&litMatcher{
							pos:        position{line: 537, col: 50, offset: 15058},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LowerExpression",
			pos:  position{line: 541, col: 1, offset: 15143},
			expr: &actionExpr{
				pos: position{line: 541, col: 20, offset: 15162},
				run: (*parser).callonLowerExpression1,
				expr: &seqExpr{
					pos: position{line: 541, col: 20, offset: 15162},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 541, col: 20, offset: 15162},
							val:        "lower",
							ignoreCase: true,
							want:       "\"LOWER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 541, col: 29, offset: 15171},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 541, col: 32, offset: 15174},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&labeledExpr{
							pos:   position{line: 541, col: 36, offset: 15178},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 541, col: 39, offset: 15181},
								name: "SelectItem",
							},
						},
						&litMatcher{
							pos:        position{line: 541, col: 50, offset: 15192},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "StringEqualsExpression",
			pos:  position{line: 545, col: 1, offset: 15277},
			expr: &actionExpr{
				pos: position{line: 545, col: 27, offset: 15303},
				run: (*parser).callonStringEqualsExpression1,
				expr: &seqExpr{
					pos: position{line: 545, col: 27, offset: 15303},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 545, col: 27, offset: 15303},
							val:        "stringequals",
							ignoreCase: true,
							want:       "\"STRINGEQUALS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 545, col: 43, offset: 15319},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 545, col: 46, offset: 15322},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 545, col: 50, offset: 15326},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 545, col: 53, offset: 15329},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 545, col: 57, offset: 15333},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 545, col: 68, offset: 15344},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 545, col: 71, offset: 15347},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 545, col: 75, offset: 15351},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 545, col: 78, offset: 15354},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 545, col: 82, offset: 15358},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 545, col: 93, offset: 15369},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 545, col: 96, offset: 15372},
							label: "ignoreCase",
							expr: &zeroOrOneExpr{
								pos: position{line: 545, col: 107, offset: 15383},
								expr: &actionExpr{
									pos: position{line: 545, col: 108, offset: 15384},
									run: (*parser).callonStringEqualsExpression17,
									expr: &seqExpr{
										pos: position{line: 545, col: 108, offset: 15384},
										exprs: []any{
											&litMatcher{
												pos:        position{line: 545, col: 108, offset: 15384},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 545, col: 112, offset: 15388},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 545, col: 115, offset: 15391},
												label: "boolean",
												expr: &ruleRefExpr{
													pos:  position{line: 545, col: 123, offset: 15399},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 545, col: 160, offset: 15436},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ToStringExpression",
			pos:  position{line: 549, col: 1, offset: 15546},
			expr: &actionExpr{
				pos: position{line: 549, col: 23, offset: 15568},
				run: (*parser).callonToStringExpression1,
				expr: &seqExpr{
					pos: position{line: 549, col: 23, offset: 15568},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 549, col: 23, offset: 15568},
							val:        "tostring",
							ignoreCase: true,
							want:       "\"TOSTRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 549, col: 35, offset: 15580},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 549, col: 38, offset: 15583},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 549, col: 42, offset: 15587},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 549, col: 45, offset: 15590},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 549, col: 48, offset: 15593},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 549, col: 59, offset: 15604},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 549, col: 62, offset: 15607},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ConcatExpression",
			pos:  position{line: 553, col: 1, offset: 15695},
			expr: &actionExpr{
				pos: position{line: 553, col: 21, offset: 15715},
				run: (*parser).callonConcatExpression1,
				expr: &seqExpr{
					pos: position{line: 553, col: 21, offset: 15715},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 553, col: 21, offset: 15715},
							val:        "concat",
							ignoreCase: true,
							want:       "\"CONCAT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 553, col: 31, offset: 15725},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 553, col: 34, offset: 15728},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 553, col: 38, offset: 15732},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 553, col: 41, offset: 15735},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 553, col: 45, offset: 15739},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 553, col: 56, offset: 15750},
							label: "others",
							expr: &oneOrMoreExpr{
								pos: position{line: 553, col: 63, offset: 15757},
								expr: &actionExpr{
									pos: position{line: 553, col: 64, offset: 15758},
									run: (*parser).callonConcatExpression11,
									expr: &seqExpr{
										pos: position{line: 553, col: 64, offset: 15758},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 553, col: 64, offset: 15758},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 553, col: 67, offset: 15761},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 553, col: 71, offset: 15765},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 553, col: 74, offset: 15768},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 553, col: 77, offset: 15771},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 553, col: 109, offset: 15803},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 553, col: 112, offset: 15806},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LeftExpression",
			pos:  position{line: 558, col: 1, offset: 15955},
			expr: &actionExpr{
				pos: position{line: 558, col: 19, offset: 15973},
				run: (*parser).callonLeftExpression1,
				expr: &seqExpr{
					pos: position{line: 558, col: 19, offset: 15973},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 558, col: 19, offset: 15973},
							val:        "left",
							ignoreCase: true,
							want:       "\"LEFT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 558, col: 27, offset: 15981},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 558, col: 30, offset: 15984},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 558, col: 34, offset: 15988},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 558, col: 37, offset: 15991},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 558, col: 40, offset: 15994},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 558, col: 51, offset: 16005},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 558, col: 54, offset: 16008},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 558, col: 58, offset: 16012},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 558, col: 61, offset: 16015},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 558, col: 68, offset: 16022},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 558, col: 79, offset: 16033},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 558, col: 82, offset: 16036},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LengthExpression",
			pos:  position{line: 562, col: 1, offset: 16128},
			expr: &actionExpr{
				pos: position{line: 562, col: 21, offset: 16148},
				run: (*parser).callonLengthExpression1,
				expr: &seqExpr{
					pos: position{line: 562, col: 21, offset: 16148},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 562, col: 21, offset: 16148},
							val:        "length",
							ignoreCase: true,
							want:       "\"LENGTH\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 562, col: 31, offset: 16158},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 562, col: 34, offset: 16161},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 562, col: 38, offset: 16165},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 562, col: 41, offset: 16168},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 562, col: 44, offset: 16171},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 562, col: 55, offset: 16182},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 562, col: 58, offset: 16185},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LTrimExpression",
			pos:  position{line: 566, col: 1, offset: 16271},
			expr: &actionExpr{
				pos: position{line: 566, col: 20, offset: 16290},
				run: (*parser).callonLTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 566, col: 20, offset: 16290},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 566, col: 20, offset: 16290},
							val:        "ltrim",
							ignoreCase: true,
							want:       "\"LTRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 566, col: 29, offset: 16299},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 566, col: 32, offset: 16302},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 566, col: 36, offset: 16306},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 566, col: 39, offset: 16309},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 566, col: 42, offset: 16312},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 566, col: 53, offset: 16323},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 566, col: 56, offset: 16326},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReplaceExpression",
			pos:  position{line: 570, col: 1, offset: 16411},
			expr: &actionExpr{
				pos: position{line: 570, col: 22, offset: 16432},
				run: (*parser).callonReplaceExpression1,
				expr: &seqExpr{
					pos: position{line: 570, col: 22, offset: 16432},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 570, col: 22, offset: 16432},
							val:        "replace",
							ignoreCase: true,
							want:       "\"REPLACE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 570, col: 33, offset: 16443},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 570, col: 36, offset: 16446},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 570, col: 40, offset: 16450},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 570, col: 43, offset: 16453},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 570, col: 47, offset: 16457},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 570, col: 58, offset: 16468},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 570, col: 61, offset: 16471},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 570, col: 65, offset: 16475},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 570, col: 68, offset: 16478},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 570, col: 72, offset: 16482},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 570, col: 83, offset: 16493},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 570, col: 86, offset: 16496},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 570, col: 90, offset: 16500},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 570, col: 93, offset: 16503},
							label: "ex3",
							expr: &ruleRefExpr{
								pos:  position{line: 570, col: 97, offset: 16507},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 570, col: 108, offset: 16518},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 570, col: 111, offset: 16521},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReplicateExpression",
			pos:  position{line: 574, col: 1, offset: 16619},
			expr: &actionExpr{
				pos: position{line: 574, col: 24, offset: 16642},
				run: (*parser).callonReplicateExpression1,
				expr: &seqExpr{
					pos: position{line: 574, col: 24, offset: 16642},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 574, col: 24, offset: 16642},
							val:        "replicate",
							ignoreCase: true,
							want:       "\"REPLICATE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 574, col: 37, offset: 16655},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 574, col: 40, offset: 16658},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 574, col: 44, offset: 16662},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 574, col: 47, offset: 16665},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 574, col: 51, offset: 16669},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 574, col: 62, offset: 16680},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 574, col: 65, offset: 16683},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 574, col: 69, offset: 16687},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 574, col: 72, offset: 16690},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 574, col: 76, offset: 16694},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 574, col: 87, offset: 16705},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 574, col: 90, offset: 16708},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReverseExpression",
			pos:  position{line: 578, col: 1, offset: 16803},
			expr: &actionExpr{
				pos: position{line: 578, col: 22, offset: 16824},
				run: (*parser).callonReverseExpression1,
				expr: &seqExpr{
					pos: position{line: 578, col: 22, offset: 16824},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 578, col: 22, offset: 16824},
							val:        "reverse",
							ignoreCase: true,
							want:       "\"REVERSE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 578, col: 33, offset: 16835},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 578, col: 36, offset: 16838},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 578, col: 40, offset: 16842},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 578, col: 43, offset: 16845},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 578, col: 46, offset: 16848},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 578, col: 57, offset: 16859},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 578, col: 60, offset: 16862},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "RightExpression",
			pos:  position{line: 582, col: 1, offset: 16949},
			expr: &actionExpr{
				pos: position{line: 582, col: 20, offset: 16968},
				run: (*parser).callonRightExpression1,
				expr: &seqExpr{
					pos: position{line: 582, col: 20, offset: 16968},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 582, col: 20, offset: 16968},
							val:        "right",
							ignoreCase: true,
							want:       "\"RIGHT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 582, col: 29, offset: 16977},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 582, col: 32, offset: 16980},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 582, col: 36, offset: 16984},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 582, col: 39, offset: 16987},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 582, col: 42, offset: 16990},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 582, col: 53, offset: 17001},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 582, col: 56, offset: 17004},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 582, col: 60, offset: 17008},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 582, col: 63, offset: 17011},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 582, col: 70, offset: 17018},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 582, col: 81, offset: 17029},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 582, col: 84, offset: 17032},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "RTrimExpression",
			pos:  position{line: 586, col: 1, offset: 17125},
			expr: &actionExpr{
				pos: position{line: 586, col: 20, offset: 17144},
				run: (*parser).callonRTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 586, col: 20, offset: 17144},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 586, col: 20, offset: 17144},
							val:        "rtrim",
							ignoreCase: true,
							want:       "\"RTRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 586, col: 29, offset: 17153},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 586, col: 32, offset: 17156},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 586, col: 36, offset: 17160},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 586, col: 39, offset: 17163},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 586, col: 42, offset: 17166},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 586, col: 53, offset: 17177},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 586, col: 56, offset: 17180},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SubstringExpression",
			pos:  position{line: 590, col: 1, offset: 17265},
			expr: &actionExpr{
				pos: position{line: 590, col: 24, offset: 17288},
				run: (*parser).callonSubstringExpression1,
				expr: &seqExpr{
					pos: position{line: 590, col: 24, offset: 17288},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 590, col: 24, offset: 17288},
							val:        "substring",
							ignoreCase: true,
							want:       "\"SUBSTRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 590, col: 37, offset: 17301},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 590, col: 40, offset: 17304},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 590, col: 44, offset: 17308},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 590, col: 47, offset: 17311},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 590, col: 50, offset: 17314},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 590, col: 61, offset: 17325},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 590, col: 64, offset: 17328},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 590, col: 68, offset: 17332},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 590, col: 71, offset: 17335},
							label: "startPos",
							expr: &ruleRefExpr{
								pos:  position{line: 590, col: 80, offset: 17344},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 590, col: 91, offset: 17355},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 590, col: 94, offset: 17358},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 590, col: 98, offset: 17362},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 590, col: 101, offset: 17365},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 590, col: 108, offset: 17372},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 590, col: 119, offset: 17383},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 590, col: 122, offset: 17386},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "TrimExpression",
			pos:  position{line: 594, col: 1, offset: 17493},
			expr: &actionExpr{
				pos: position{line: 594, col: 19, offset: 17511},
				run: (*parser).callonTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 594, col: 19, offset: 17511},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 594, col: 19, offset: 17511},
							val:        "trim",
							ignoreCase: true,
							want:       "\"TRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 594, col: 27, offset: 17519},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 594, col: 30, offset: 17522},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 594, col: 34, offset: 17526},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 594, col: 37, offset: 17529},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 594, col: 40, offset: 17532},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 594, col: 51, offset: 17543},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 594, col: 54, offset: 17546},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ThreeArgumentStringFunctionExpression",
			pos:  position{line: 598, col: 1, offset: 17630},
			expr: &actionExpr{
				pos: position{line: 598, col: 42, offset: 17671},
				run: (*parser).callonThreeArgumentStringFunctionExpression1,
				expr: &seqExpr{
					pos: position{line: 598, col: 42, offset: 17671},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 598, col: 42, offset: 17671},
							label: "function",
							expr: &ruleRefExpr{
								pos:  position{line: 598, col: 51, offset: 17680},
								name: "ThreeArgumentStringFunction",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 598, col: 79, offset: 17708},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 598, col: 82, offset: 17711},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 598, col: 86, offset: 17715},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 598, col: 89, offset: 17718},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 598, col: 93, offset: 17722},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 598, col: 104, offset: 17733},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 598, col: 107, offset: 17736},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 598, col: 111, offset: 17740},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 598, col: 114, offset: 17743},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 598, col: 118, offset: 17747},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 598, col: 129, offset: 17758},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 598, col: 132, offset: 17761},
							label: "ignoreCase",
							expr: &zeroOrOneExpr{
								pos: position{line: 598, col: 143, offset: 17772},
								expr: &actionExpr{
									pos: position{line: 598, col: 144, offset: 17773},
									run: (*parser).callonThreeArgumentStringFunctionExpression18,
									expr: &seqExpr{
										pos: position{line: 598, col: 144, offset: 17773},
										exprs: []any{
											&litMatcher{
												pos:        position{line: 598, col: 144, offset: 17773},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 598, col: 148, offset: 17777},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 598, col: 151, offset: 17780},
												label: "boolean",
												expr: &ruleRefExpr{
													pos:  position{line: 598, col: 159, offset: 17788},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 598, col: 196, offset: 17825},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ThreeArgumentStringFunction",
			pos:  position{line: 616, col: 1, offset: 18347},
			expr: &actionExpr{
				pos: position{line: 616, col: 32, offset: 18378},
				run: (*parser).callonThreeArgumentStringFunction1,
				expr: &choiceExpr{
					pos: position{line: 616, col: 33, offset: 18379},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 616, col: 33, offset: 18379},
							val:        "contains",
							ignoreCase: true,
							want:       "\"CONTAINS\"i",
						},
						&litMatcher{
							pos:        position{line: 616, col: 47, offset: 18393},
							val:        "endswith",
							ignoreCase: true,
							want:       "\"ENDSWITH\"i",
						},
						&litMatcher{
							pos:        position{line: 616, col: 61, offset: 18407},
							val:        "startswith",
							ignoreCase: true,
							want:       "\"STARTSWITH\"i",
						},
						&litMatcher{
							pos:        position{line: 616, col: 77, offset: 18423},
							val:        "index_of",
							ignoreCase: true,
							want:       "\"INDEX_OF\"i",
						},
					},
				},
			},
		},
		{
			name: "IsDefined",
			pos:  position{line: 620, col: 1, offset: 18472},
			expr: &actionExpr{
				pos: position{line: 620, col: 14, offset: 18485},
				run: (*parser).callonIsDefined1,
				expr: &seqExpr{
					pos: position{line: 620, col: 14, offset: 18485},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 620, col: 14, offset: 18485},
							val:        "is_defined",
							ignoreCase: true,
							want:       "\"IS_DEFINED\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 620, col: 28, offset: 18499},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 620, col: 31, offset: 18502},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 620, col: 35, offset: 18506},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 620, col: 38, offset: 18509},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 620, col: 41, offset: 18512},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 620, col: 52, offset: 18523},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 620, col: 55, offset: 18526},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsArray",
			pos:  position{line: 624, col: 1, offset: 18615},
			expr: &actionExpr{
				pos: position{line: 624, col: 12, offset: 18626},
				run: (*parser).callonIsArray1,
				expr: &seqExpr{
					pos: position{line: 624, col: 12, offset: 18626},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 624, col: 12, offset: 18626},
							val:        "is_array",
							ignoreCase: true,
							want:       "\"IS_ARRAY\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 624, col: 24, offset: 18638},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 624, col: 27, offset: 18641},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 624, col: 31, offset: 18645},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 624, col: 34, offset: 18648},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 624, col: 37, offset: 18651},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 624, col: 48, offset: 18662},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 624, col: 51, offset: 18665},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsBool",
			pos:  position{line: 628, col: 1, offset: 18752},
			expr: &actionExpr{
				pos: position{line: 628, col: 11, offset: 18762},
				run: (*parser).callonIsBool1,
				expr: &seqExpr{
					pos: position{line: 628, col: 11, offset: 18762},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 628, col: 11, offset: 18762},
							val:        "is_bool",
							ignoreCase: true,
							want:       "\"IS_BOOL\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 628, col: 22, offset: 18773},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 628, col: 25, offset: 18776},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 628, col: 29, offset: 18780},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 628, col: 32, offset: 18783},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 628, col: 35, offset: 18786},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 628, col: 46, offset: 18797},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 628, col: 49, offset: 18800},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsFiniteNumber",
			pos:  position{line: 632, col: 1, offset: 18886},
			expr: &actionExpr{
				pos: position{line: 632, col: 19, offset: 18904},
				run: (*parser).callonIsFiniteNumber1,
				expr: &seqExpr{
					pos: position{line: 632, col: 19, offset: 18904},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 632, col: 19, offset: 18904},
							val:        "is_finite_number",
							ignoreCase: true,
							want:       "\"IS_FINITE_NUMBER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 632, col: 39, offset: 18924},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 632, col: 42, offset: 18927},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 632, col: 46, offset: 18931},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 632, col: 49, offset: 18934},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 632, col: 52, offset: 18937},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 632, col: 63, offset: 18948},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 632, col: 66, offset: 18951},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsInteger",
			pos:  position{line: 636, col: 1, offset: 19045},
			expr: &actionExpr{
				pos: position{line: 636, col: 14, offset: 19058},
				run: (*parser).callonIsInteger1,
				expr: &seqExpr{
					pos: position{line: 636, col: 14, offset: 19058},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 636, col: 14, offset: 19058},
							val:        "is_integer",
							ignoreCase: true,
							want:       "\"IS_INTEGER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 636, col: 28, offset: 19072},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 636, col: 31, offset: 19075},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 636, col: 35, offset: 19079},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 636, col: 38, offset: 19082},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 636, col: 41, offset: 19085},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 636, col: 52, offset: 19096},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 636, col: 55, offset: 19099},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsNull",
			pos:  position{line: 640, col: 1, offset: 19188},
			expr: &actionExpr{
				pos: position{line: 640, col: 11, offset: 19198},
				run: (*parser).callonIsNull1,
				expr: &seqExpr{
					pos: position{line: 640, col: 11, offset: 19198},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 640, col: 11, offset: 19198},
							val:        "is_null",
							ignoreCase: true,
							want:       "\"IS_NULL\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 640, col: 22, offset: 19209},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 640, col: 25, offset: 19212},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 640, col: 29, offset: 19216},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 640, col: 32, offset: 19219},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 640, col: 35, offset: 19222},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 640, col: 46, offset: 19233},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 640, col: 49, offset: 19236},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsNumber",
			pos:  position{line: 644, col: 1, offset: 19322},
			expr: &actionExpr{
				pos: position{line: 644, col: 13, offset: 19334},
				run: (*parser).callonIsNumber1,
				expr: &seqExpr{
					pos: position{line: 644, col: 13, offset: 19334},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 644, col: 13, offset: 19334},
							val:        "is_number",
							ignoreCase: true,
							want:       "\"IS_NUMBER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 644, col: 26, offset: 19347},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 644, col: 29, offset: 19350},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 644, col: 33, offset: 19354},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 644, col: 36, offset: 19357},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 644, col: 39, offset: 19360},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 644, col: 50, offset: 19371},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 644, col: 53, offset: 19374},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsObject",
			pos:  position{line: 648, col: 1, offset: 19462},
			expr: &actionExpr{
				pos: position{line: 648, col: 13, offset: 19474},
				run: (*parser).callonIsObject1,
				expr: &seqExpr{
					pos: position{line: 648, col: 13, offset: 19474},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 648, col: 13, offset: 19474},
							val:        "is_object",
							ignoreCase: true,
							want:       "\"IS_OBJECT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 648, col: 26, offset: 19487},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 648, col: 29, offset: 19490},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 648, col: 33, offset: 19494},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 648, col: 36, offset: 19497},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 648, col: 39, offset: 19500},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 648, col: 50, offset: 19511},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 648, col: 53, offset: 19514},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsPrimitive",
			pos:  position{line: 652, col: 1, offset: 19602},
			expr: &actionExpr{
				pos: position{line: 652, col: 16, offset: 19617},
				run: (*parser).callonIsPrimitive1,
				expr: &seqExpr{
					pos: position{line: 652, col: 16, offset: 19617},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 652, col: 16, offset: 19617},
							val:        "is_primitive",
							ignoreCase: true,
							want:       "\"IS_PRIMITIVE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 652, col: 32, offset: 19633},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 652, col: 35, offset: 19636},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 652, col: 39, offset: 19640},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 652, col: 42, offset: 19643},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 652, col: 45, offset: 19646},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 652, col: 56, offset: 19657},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 652, col: 59, offset: 19660},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsString",
			pos:  position{line: 656, col: 1, offset: 19751},
			expr: &actionExpr{
				pos: position{line: 656, col: 13, offset: 19763},
				run: (*parser).callonIsString1,
				expr: &seqExpr{
					pos: position{line: 656, col: 13, offset: 19763},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 656, col: 13, offset: 19763},
							val:        "is_string",
							ignoreCase: true,
							want:       "\"IS_STRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 656, col: 26, offset: 19776},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 656, col: 29, offset: 19779},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 656, col: 33, offset: 19783},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 656, col: 36, offset: 19786},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 656, col: 39, offset: 19789},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 656, col: 50, offset: 19800},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 656, col: 53, offset: 19803},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayConcatExpression",
			pos:  position{line: 660, col: 1, offset: 19891},
			expr: &actionExpr{
				pos: position{line: 660, col: 26, offset: 19916},
				run: (*parser).callonArrayConcatExpression1,
				expr: &seqExpr{
					pos: position{line: 660, col: 26, offset: 19916},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 660, col: 26, offset: 19916},
							val:        "array_concat",
							ignoreCase: true,
							want:       "\"ARRAY_CONCAT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 660, col: 42, offset: 19932},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 660, col: 45, offset: 19935},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 660, col: 49, offset: 19939},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 660, col: 52, offset: 19942},
							label: "arrays",
							expr: &ruleRefExpr{
								pos:  position{line: 660, col: 59, offset: 19949},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 660, col: 70, offset: 19960},
							label: "others",
							expr: &oneOrMoreExpr{
								pos: position{line: 660, col: 77, offset: 19967},
								expr: &actionExpr{
									pos: position{line: 660, col: 78, offset: 19968},
									run: (*parser).callonArrayConcatExpression11,
									expr: &seqExpr{
										pos: position{line: 660, col: 78, offset: 19968},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 660, col: 78, offset: 19968},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 660, col: 81, offset: 19971},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 660, col: 85, offset: 19975},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 660, col: 88, offset: 19978},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 660, col: 91, offset: 19981},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 660, col: 123, offset: 20013},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 660, col: 126, offset: 20016},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayContainsExpression",
			pos:  position{line: 664, col: 1, offset: 20146},
			expr: &actionExpr{
				pos: position{line: 664, col: 28, offset: 20173},
				run: (*parser).callonArrayContainsExpression1,
				expr: &seqExpr{
					pos: position{line: 664, col: 28, offset: 20173},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 664, col: 28, offset: 20173},
							val:        "array_contains",
							ignoreCase: true,
							want:       "\"ARRAY_CONTAINS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 664, col: 46, offset: 20191},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 664, col: 49, offset: 20194},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 664, col: 53, offset: 20198},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 664, col: 56, offset: 20201},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 664, col: 62, offset: 20207},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 664, col: 73, offset: 20218},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 664, col: 76, offset: 20221},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 664, col: 80, offset: 20225},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 664, col: 83, offset: 20228},
							label: "item",
							expr: &ruleRefExpr{
								pos:  position{line: 664, col: 88, offset: 20233},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 664, col: 99, offset: 20244},
							label: "partialMatch",
							expr: &zeroOrOneExpr{
								pos: position{line: 664, col: 112, offset: 20257},
								expr: &actionExpr{
									pos: position{line: 664, col: 113, offset: 20258},
									run: (*parser).callonArrayContainsExpression16,
									expr: &seqExpr{
										pos: position{line: 664, col: 113, offset: 20258},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 664, col: 113, offset: 20258},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 664, col: 116, offset: 20261},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 664, col: 120, offset: 20265},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 664, col: 123, offset: 20268},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 664, col: 126, offset: 20271},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 664, col: 158, offset: 20303},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 664, col: 161, offset: 20306},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayContainsAnyExpression",
			pos:  position{line: 668, col: 1, offset: 20422},
			expr: &actionExpr{
				pos: position{line: 668, col: 31, offset: 20452},
				run: (*parser).callonArrayContainsAnyExpression1,
				expr: &seqExpr{
					pos: position{line: 668, col: 31, offset: 20452},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 668, col: 31, offset: 20452},
							val:        "array_contains_any",
							ignoreCase: true,
							want:       "\"ARRAY_CONTAINS_ANY\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 668, col: 53, offset: 20474},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 668, col: 56, offset: 20477},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 668, col: 60, offset: 20481},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 668, col: 63, offset: 20484},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 668, col: 69, offset: 20490},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 668, col: 80, offset: 20501},
							label: "items",
							expr: &oneOrMoreExpr{
								pos: position{line: 668, col: 86, offset: 20507},
								expr: &actionExpr{
									pos: position{line: 668, col: 87, offset: 20508},
									run: (*parser).callonArrayContainsAnyExpression11,
									expr: &seqExpr{
										pos: position{line: 668, col: 87, offset: 20508},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 668, col: 87, offset: 20508},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 668, col: 90, offset: 20511},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 668, col: 94, offset: 20515},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 668, col: 97, offset: 20518},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 668, col: 100, offset: 20521},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 668, col: 132, offset: 20553},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 668, col: 135, offset: 20556},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayContainsAllExpression",
			pos:  position{line: 672, col: 1, offset: 20689},
			expr: &actionExpr{
				pos: position{line: 672, col: 31, offset: 20719},
				run: (*parser).callonArrayContainsAllExpression1,
				expr: &seqExpr{
					pos: position{line: 672, col: 31, offset: 20719},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 672, col: 31, offset: 20719},
							val:        "array_contains_all",
							ignoreCase: true,
							want:       "\"ARRAY_CONTAINS_ALL\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 672, col: 53, offset: 20741},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 672, col: 56, offset: 20744},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 672, col: 60, offset: 20748},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 672, col: 63, offset: 20751},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 672, col: 69, offset: 20757},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 672, col: 80, offset: 20768},
							label: "items",
							expr: &oneOrMoreExpr{
								pos: position{line: 672, col: 86, offset: 20774},
								expr: &actionExpr{
									pos: position{line: 672, col: 87, offset: 20775},
									run: (*parser).callonArrayContainsAllExpression11,
									expr: &seqExpr{
										pos: position{line: 672, col: 87, offset: 20775},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 672, col: 87, offset: 20775},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 672, col: 90, offset: 20778},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 672, col: 94, offset: 20782},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 672, col: 97, offset: 20785},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 672, col: 100, offset: 20788},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 672, col: 132, offset: 20820},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 672, col: 135, offset: 20823},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayLengthExpression",
			pos:  position{line: 676, col: 1, offset: 20956},
			expr: &actionExpr{
				pos: position{line: 676, col: 26, offset: 20981},
				run: (*parser).callonArrayLengthExpression1,
				expr: &seqExpr{
					pos: position{line: 676, col: 26, offset: 20981},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 676, col: 26, offset: 20981},
							val:        "array_length",
							ignoreCase: true,
							want:       "\"ARRAY_LENGTH\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 676, col: 42, offset: 20997},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 676, col: 45, offset: 21000},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 676, col: 49, offset: 21004},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 676, col: 52, offset: 21007},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 676, col: 58, offset: 21013},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 676, col: 69, offset: 21024},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 676, col: 72, offset: 21027},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArraySliceExpression",
			pos:  position{line: 680, col: 1, offset: 21121},
			expr: &actionExpr{
				pos: position{line: 680, col: 25, offset: 21145},
				run: (*parser).callonArraySliceExpression1,
				expr: &seqExpr{
					pos: position{line: 680, col: 25, offset: 21145},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 680, col: 25, offset: 21145},
							val:        "array_slice",
							ignoreCase: true,
							want:       "\"ARRAY_SLICE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 680, col: 40, offset: 21160},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 680, col: 43, offset: 21163},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 680, col: 47, offset: 21167},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 680, col: 50, offset: 21170},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 680, col: 56, offset: 21176},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 680, col: 67, offset: 21187},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 680, col: 70, offset: 21190},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 680, col: 74, offset: 21194},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 680, col: 77, offset: 21197},
							label: "start",
							expr: &ruleRefExpr{
								pos:  position{line: 680, col: 83, offset: 21203},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 680, col: 94, offset: 21214},
							label: "length",
							expr: &zeroOrOneExpr{
								pos: position{line: 680, col: 101, offset: 21221},
								expr: &actionExpr{
									pos: position{line: 680, col: 102, offset: 21222},
									run: (*parser).callonArraySliceExpression16,
									expr: &seqExpr{
										pos: position{line: 680, col: 102, offset: 21222},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 680, col: 102, offset: 21222},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 680, col: 105, offset: 21225},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 680, col: 109, offset: 21229},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 680, col: 112, offset: 21232},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 680, col: 115, offset: 21235},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 680, col: 147, offset: 21267},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 680, col: 150, offset: 21270},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SetIntersectExpression",
			pos:  position{line: 684, col: 1, offset: 21378},
			expr: &actionExpr{
				pos: position{line: 684, col: 27, offset: 21404},
				run: (*parser).callonSetIntersectExpression1,
				expr: &seqExpr{
					pos: position{line: 684, col: 27, offset: 21404},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 684, col: 27, offset: 21404},
							val:        "setintersect",
							ignoreCase: true,
							want:       "\"SetIntersect\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 684, col: 43, offset: 21420},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 684, col: 46, offset: 21423},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 684, col: 50, offset: 21427},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 684, col: 53, offset: 21430},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 684, col: 58, offset: 21435},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 684, col: 69, offset: 21446},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 684, col: 72, offset: 21449},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 684, col: 76, offset: 21453},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 684, col: 79, offset: 21456},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 684, col: 84, offset: 21461},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 684, col: 95, offset: 21472},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 684, col: 98, offset: 21475},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SetUnionExpression",
			pos:  position{line: 688, col: 1, offset: 21575},
			expr: &actionExpr{
				pos: position{line: 688, col: 23, offset: 21597},
				run: (*parser).callonSetUnionExpression1,
				expr: &seqExpr{
					pos: position{line: 688, col: 23, offset: 21597},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 688, col: 23, offset: 21597},
							val:        "setunion",
							ignoreCase: true,
							want:       "\"SetUnion\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 688, col: 35, offset: 21609},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 688, col: 38, offset: 21612},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 688, col: 42, offset: 21616},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 688, col: 45, offset: 21619},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 688, col: 50, offset: 21624},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 688, col: 61, offset: 21635},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 688, col: 64, offset: 21638},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 688, col: 68, offset: 21642},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 688, col: 71, offset: 21645},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 688, col: 76, offset: 21650},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 688, col: 87, offset: 21661},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 688, col: 90, offset: 21664},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IifExpression",
			pos:  position{line: 692, col: 1, offset: 21760},
			expr: &actionExpr{
				pos: position{line: 692, col: 18, offset: 21777},
				run: (*parser).callonIifExpression1,
				expr: &seqExpr{
					pos: position{line: 692, col: 18, offset: 21777},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 692, col: 18, offset: 21777},
							val:        "iif",
							ignoreCase: true,
							want:       "\"IIF\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 692, col: 25, offset: 21784},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 692, col: 28, offset: 21787},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 692, col: 32, offset: 21791},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 692, col: 35, offset: 21794},
							label: "condition",
							expr: &ruleRefExpr{
								pos:  position{line: 692, col: 45, offset: 21804},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 692, col: 56, offset: 21815},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 692, col: 59, offset: 21818},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 692, col: 63, offset: 21822},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 692, col: 66, offset: 21825},
							label: "trueValue",
							expr: &ruleRefExpr{
								pos:  position{line: 692, col: 76, offset: 21835},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 692, col: 87, offset: 21846},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 692, col: 90, offset: 21849},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 692, col: 94, offset: 21853},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 692, col: 97, offset: 21856},
							label: "falseValue",
							expr: &ruleRefExpr{
								pos:  position{line: 692, col: 108, offset: 21867},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 692, col: 119, offset: 21878},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 692, col: 122, offset: 21881},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAbsExpression",
			pos:  position{line: 696, col: 1, offset: 21994},
			expr: &actionExpr{
				pos: position{line: 696, col: 22, offset: 22015},
				run: (*parser).callonMathAbsExpression1,
				expr: &seqExpr{
					pos: position{line: 696, col: 22, offset: 22015},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 696, col: 22, offset: 22015},
							val:        "abs",
							ignoreCase: true,
							want:       "\"ABS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 696, col: 29, offset: 22022},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 696, col: 32, offset: 22025},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 696, col: 36, offset: 22029},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 696, col: 39, offset: 22032},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 696, col: 42, offset: 22035},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 696, col: 53, offset: 22046},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 696, col: 56, offset: 22049},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAcosExpression",
			pos:  position{line: 697, col: 1, offset: 22131},
			expr: &actionExpr{
				pos: position{line: 697, col: 23, offset: 22153},
				run: (*parser).callonMathAcosExpression1,
				expr: &seqExpr{
					pos: position{line: 697, col: 23, offset: 22153},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 697, col: 23, offset: 22153},
							val:        "acos",
							ignoreCase: true,
							want:       "\"ACOS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 697, col: 31, offset: 22161},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 697, col: 34, offset: 22164},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 697, col: 38, offset: 22168},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 697, col: 41, offset: 22171},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 697, col: 44, offset: 22174},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 697, col: 55, offset: 22185},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 697, col: 58, offset: 22188},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAsinExpression",
			pos:  position{line: 698, col: 1, offset: 22271},
			expr: &actionExpr{
				pos: position{line: 698, col: 23, offset: 22293},
				run: (*parser).callonMathAsinExpression1,
				expr: &seqExpr{
					pos: position{line: 698, col: 23, offset: 22293},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 698, col: 23, offset: 22293},
							val:        "asin",
							ignoreCase: true,
							want:       "\"ASIN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 698, col: 31, offset: 22301},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 698, col: 34, offset: 22304},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 698, col: 38, offset: 22308},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 698, col: 41, offset: 22311},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 698, col: 44, offset: 22314},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 698, col: 55, offset: 22325},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 698, col: 58, offset: 22328},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAtanExpression",
			pos:  position{line: 699, col: 1, offset: 22411},
			expr: &actionExpr{
				pos: position{line: 699, col: 23, offset: 22433},
				run: (*parser).callonMathAtanExpression1,
				expr: &seqExpr{
					pos: position{line: 699, col: 23, offset: 22433},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 699, col: 23, offset: 22433},
							val:        "atan",
							ignoreCase: true,
							want:       "\"ATAN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 699, col: 31, offset: 22441},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 699, col: 34, offset: 22444},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 699, col: 38, offset: 22448},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 699, col: 41, offset: 22451},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 699, col: 44, offset: 22454},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 699, col: 55, offset: 22465},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 699, col: 58, offset: 22468},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathCeilingExpression",
			pos:  position{line: 700, col: 1, offset: 22551},
			expr: &actionExpr{
				pos: position{line: 700, col: 26, offset: 22576},
				run: (*parser).callonMathCeilingExpression1,
				expr: &seqExpr{
					pos: position{line: 700, col: 26, offset: 22576},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 700, col: 26, offset: 22576},
							val:        "ceiling",
							ignoreCase: true,
							want:       "\"CEILING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 700, col: 37, offset: 22587},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 700, col: 40, offset: 22590},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 700, col: 44, offset: 22594},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 700, col: 47, offset: 22597},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 700, col: 50, offset: 22600},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 700, col: 61, offset: 22611},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 700, col: 64, offset: 22614},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathCosExpression",
			pos:  position{line: 701, col: 1, offset: 22700},
			expr: &actionExpr{
				pos: position{line: 701, col: 22, offset: 22721},
				run: (*parser).callonMathCosExpression1,
				expr: &seqExpr{
					pos: position{line: 701, col: 22, offset: 22721},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 701, col: 22, offset: 22721},
							val:        "cos",
							ignoreCase: true,
							want:       "\"COS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 701, col: 29, offset: 22728},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 701, col: 32, offset: 22731},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 701, col: 36, offset: 22735},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 701, col: 39, offset: 22738},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 701, col: 42, offset: 22741},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 701, col: 53, offset: 22752},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 701, col: 56, offset: 22755},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathCotExpression",
			pos:  position{line: 702, col: 1, offset: 22837},
			expr: &actionExpr{
				pos: position{line: 702, col: 22, offset: 22858},
				run: (*parser).callonMathCotExpression1,
				expr: &seqExpr{
					pos: position{line: 702, col: 22, offset: 22858},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 702, col: 22, offset: 22858},
							val:        "cot",
							ignoreCase: true,
							want:       "\"COT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 702, col: 29, offset: 22865},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 702, col: 32, offset: 22868},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 702, col: 36, offset: 22872},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 702, col: 39, offset: 22875},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 702, col: 42, offset: 22878},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 702, col: 53, offset: 22889},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 702, col: 56, offset: 22892},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathDegreesExpression",
			pos:  position{line: 703, col: 1, offset: 22974},
			expr: &actionExpr{
				pos: position{line: 703, col: 26, offset: 22999},
				run: (*parser).callonMathDegreesExpression1,
				expr: &seqExpr{
					pos: position{line: 703, col: 26, offset: 22999},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 703, col: 26, offset: 22999},
							val:        "degrees",
							ignoreCase: true,
							want:       "\"DEGREES\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 703, col: 37, offset: 23010},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 703, col: 40, offset: 23013},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 703, col: 44, offset: 23017},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 703, col: 47, offset: 23020},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 703, col: 50, offset: 23023},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 703, col: 61, offset: 23034},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 703, col: 64, offset: 23037},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathExpExpression",
			pos:  position{line: 704, col: 1, offset: 23123},
			expr: &actionExpr{
				pos: position{line: 704, col: 22, offset: 23144},
				run: (*parser).callonMathExpExpression1,
				expr: &seqExpr{
					pos: position{line: 704, col: 22, offset: 23144},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 704, col: 22, offset: 23144},
							val:        "exp",
							ignoreCase: true,
							want:       "\"EXP\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 704, col: 29, offset: 23151},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 704, col: 32, offset: 23154},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 704, col: 36, offset: 23158},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 704, col: 39, offset: 23161},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 704, col: 42, offset: 23164},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 704, col: 53, offset: 23175},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 704, col: 56, offset: 23178},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathFloorExpression",
			pos:  position{line: 705, col: 1, offset: 23260},
			expr: &actionExpr{
				pos: position{line: 705, col: 24, offset: 23283},
				run: (*parser).callonMathFloorExpression1,
				expr: &seqExpr{
					pos: position{line: 705, col: 24, offset: 23283},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 705, col: 24, offset: 23283},
							val:        "floor",
							ignoreCase: true,
							want:       "\"FLOOR\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 705, col: 33, offset: 23292},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 705, col: 36, offset: 23295},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 705, col: 40, offset: 23299},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 705, col: 43, offset: 23302},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 705, col: 46, offset: 23305},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 705, col: 57, offset: 23316},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 705, col: 60, offset: 23319},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitNotExpression",
			pos:  position{line: 706, col: 1, offset: 23403},
			expr: &actionExpr{
				pos: position{line: 706, col: 28, offset: 23430},
				run: (*parser).callonMathIntBitNotExpression1,
				expr: &seqExpr{
					pos: position{line: 706, col: 28, offset: 23430},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 706, col: 28, offset: 23430},
							val:        "intbitnot",
							ignoreCase: true,
							want:       "\"IntBitNot\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 706, col: 41, offset: 23443},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 706, col: 44, offset: 23446},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 706, col: 48, offset: 23450},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 706, col: 51, offset: 23453},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 706, col: 54, offset: 23456},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 706, col: 65, offset: 23467},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 706, col: 68, offset: 23470},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathLog10Expression",
			pos:  position{line: 707, col: 1, offset: 23558},
			expr: &actionExpr{
				pos: position{line: 707, col: 24, offset: 23581},
				run: (*parser).callonMathLog10Expression1,
				expr: &seqExpr{
					pos: position{line: 707, col: 24, offset: 23581},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 707, col: 24, offset: 23581},
							val:        "log10",
							ignoreCase: true,
							want:       "\"LOG10\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 707, col: 33, offset: 23590},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 707, col: 36, offset: 23593},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 707, col: 40, offset: 23597},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 707, col: 43, offset: 23600},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 707, col: 46, offset: 23603},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 707, col: 57, offset: 23614},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 707, col: 60, offset: 23617},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathRadiansExpression",
			pos:  position{line: 708, col: 1, offset: 23701},
			expr: &actionExpr{
				pos: position{line: 708, col: 26, offset: 23726},
				run: (*parser).callonMathRadiansExpression1,
				expr: &seqExpr{
					pos: position{line: 708, col: 26, offset: 23726},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 708, col: 26, offset: 23726},
							val:        "radians",
							ignoreCase: true,
							want:       "\"RADIANS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 708, col: 37, offset: 23737},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 708, col: 40, offset: 23740},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 708, col: 44, offset: 23744},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 708, col: 47, offset: 23747},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 708, col: 50, offset: 23750},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 708, col: 61, offset: 23761},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 708, col: 64, offset: 23764},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathRoundExpression",
			pos:  position{line: 709, col: 1, offset: 23850},
			expr: &actionExpr{
				pos: position{line: 709, col: 24, offset: 23873},
				run: (*parser).callonMathRoundExpression1,
				expr: &seqExpr{
					pos: position{line: 709, col: 24, offset: 23873},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 709, col: 24, offset: 23873},
							val:        "round",
							ignoreCase: true,
							want:       "\"ROUND\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 709, col: 33, offset: 23882},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 709, col: 36, offset: 23885},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 709, col: 40, offset: 23889},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 709, col: 43, offset: 23892},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 709, col: 46, offset: 23895},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 709, col: 57, offset: 23906},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 709, col: 60, offset: 23909},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSignExpression",
			pos:  position{line: 710, col: 1, offset: 23993},
			expr: &actionExpr{
				pos: position{line: 710, col: 23, offset: 24015},
				run: (*parser).callonMathSignExpression1,
				expr: &seqExpr{
					pos: position{line: 710, col: 23, offset: 24015},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 710, col: 23, offset: 24015},
							val:        "sign",
							ignoreCase: true,
							want:       "\"SIGN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 710, col: 31, offset: 24023},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 710, col: 34, offset: 24026},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 710, col: 38, offset: 24030},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 710, col: 41, offset: 24033},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 710, col: 44, offset: 24036},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 710, col: 55, offset: 24047},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 710, col: 58, offset: 24050},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSinExpression",
			pos:  position{line: 711, col: 1, offset: 24133},
			expr: &actionExpr{
				pos: position{line: 711, col: 22, offset: 24154},
				run: (*parser).callonMathSinExpression1,
				expr: &seqExpr{
					pos: position{line: 711, col: 22, offset: 24154},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 711, col: 22, offset: 24154},
							val:        "sin",
							ignoreCase: true,
							want:       "\"SIN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 711, col: 29, offset: 24161},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 711, col: 32, offset: 24164},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 711, col: 36, offset: 24168},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 711, col: 39, offset: 24171},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 711, col: 42, offset: 24174},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 711, col: 53, offset: 24185},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 711, col: 56, offset: 24188},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSqrtExpression",
			pos:  position{line: 712, col: 1, offset: 24270},
			expr: &actionExpr{
				pos: position{line: 712, col: 23, offset: 24292},
				run: (*parser).callonMathSqrtExpression1,
				expr: &seqExpr{
					pos: position{line: 712, col: 23, offset: 24292},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 712, col: 23, offset: 24292},
							val:        "sqrt",
							ignoreCase: true,
							want:       "\"SQRT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 712, col: 31, offset: 24300},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 712, col: 34, offset: 24303},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 712, col: 38, offset: 24307},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 712, col: 41, offset: 24310},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 712, col: 44, offset: 24313},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 712, col: 55, offset: 24324},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 712, col: 58, offset: 24327},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSquareExpression",
			pos:  position{line: 713, col: 1, offset: 24410},
			expr: &actionExpr{
				pos: position{line: 713, col: 25, offset: 24434},
				run: (*parser).callonMathSquareExpression1,
				expr: &seqExpr{
					pos: position{line: 713, col: 25, offset: 24434},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 713, col: 25, offset: 24434},
							val:        "square",
							ignoreCase: true,
							want:       "\"SQUARE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 713, col: 35, offset: 24444},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 713, col: 38, offset: 24447},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 713, col: 42, offset: 24451},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 713, col: 45, offset: 24454},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 713, col: 48, offset: 24457},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 713, col: 59, offset: 24468},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 713, col: 62, offset: 24471},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathTanExpression",
			pos:  position{line: 714, col: 1, offset: 24556},
			expr: &actionExpr{
				pos: position{line: 714, col: 22, offset: 24577},
				run: (*parser).callonMathTanExpression1,
				expr: &seqExpr{
					pos: position{line: 714, col: 22, offset: 24577},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 714, col: 22, offset: 24577},
							val:        "tan",
							ignoreCase: true,
							want:       "\"TAN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 714, col: 29, offset: 24584},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 714, col: 32, offset: 24587},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 714, col: 36, offset: 24591},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 714, col: 39, offset: 24594},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 714, col: 42, offset: 24597},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 714, col: 53, offset: 24608},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 714, col: 56, offset: 24611},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathTruncExpression",
			pos:  position{line: 715, col: 1, offset: 24693},
			expr: &actionExpr{
				pos: position{line: 715, col: 24, offset: 24716},
				run: (*parser).callonMathTruncExpression1,
				expr: &seqExpr{
					pos: position{line: 715, col: 24, offset: 24716},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 715, col: 24, offset: 24716},
							val:        "trunc",
							ignoreCase: true,
							want:       "\"TRUNC\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 715, col: 33, offset: 24725},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 715, col: 36, offset: 24728},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 715, col: 40, offset: 24732},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 715, col: 43, offset: 24735},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 715, col: 46, offset: 24738},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 715, col: 57, offset: 24749},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 715, col: 60, offset: 24752},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAtn2Expression",
			pos:  position{line: 717, col: 1, offset: 24837},
			expr: &actionExpr{
				pos: position{line: 717, col: 23, offset: 24859},
				run: (*parser).callonMathAtn2Expression1,
				expr: &seqExpr{
					pos: position{line: 717, col: 23, offset: 24859},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 717, col: 23, offset: 24859},
							val:        "atn2",
							ignoreCase: true,
							want:       "\"ATN2\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 717, col: 31, offset: 24867},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 717, col: 34, offset: 24870},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 717, col: 38, offset: 24874},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 717, col: 41, offset: 24877},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 717, col: 46, offset: 24882},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 717, col: 57, offset: 24893},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 717, col: 60, offset: 24896},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 717, col: 64, offset: 24900},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 717, col: 67, offset: 24903},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 717, col: 72, offset: 24908},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 717, col: 83, offset: 24919},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 717, col: 86, offset: 24922},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntAddExpression",
			pos:  position{line: 718, col: 1, offset: 25013},
			expr: &actionExpr{
				pos: position{line: 718, col: 25, offset: 25037},
				run: (*parser).callonMathIntAddExpression1,
				expr: &seqExpr{
					pos: position{line: 718, col: 25, offset: 25037},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 718, col: 25, offset: 25037},
							val:        "intadd",
							ignoreCase: true,
							want:       "\"IntAdd\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 718, col: 35, offset: 25047},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 718, col: 38, offset: 25050},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 718, col: 42, offset: 25054},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 718, col: 45, offset: 25057},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 718, col: 50, offset: 25062},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 718, col: 61, offset: 25073},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 718, col: 64, offset: 25076},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 718, col: 68, offset: 25080},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 718, col: 71, offset: 25083},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 718, col: 76, offset: 25088},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 718, col: 87, offset: 25099},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 718, col: 90, offset: 25102},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitAndExpression",
			pos:  position{line: 719, col: 1, offset: 25195},
			expr: &actionExpr{
				pos: position{line: 719, col: 28, offset: 25222},
				run: (*parser).callonMathIntBitAndExpression1,
				expr: &seqExpr{
					pos: position{line: 719, col: 28, offset: 25222},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 719, col: 28, offset: 25222},
							val:        "intbitand",
							ignoreCase: true,
							want:       "\"IntBitAnd\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 719, col: 41, offset: 25235},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 719, col: 44, offset: 25238},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 719, col: 48, offset: 25242},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 719, col: 51, offset: 25245},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 719, col: 56, offset: 25250},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 719, col: 67, offset: 25261},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 719, col: 70, offset: 25264},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 719, col: 74, offset: 25268},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 719, col: 77, offset: 25271},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 719, col: 82, offset: 25276},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 719, col: 93, offset: 25287},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 719, col: 96, offset: 25290},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitLeftShiftExpression",
			pos:  position{line: 720, col: 1, offset: 25386},
			expr: &actionExpr{
				pos: position{line: 720, col: 34, offset: 25419},
				run: (*parser).callonMathIntBitLeftShiftExpression1,
				expr: &seqExpr{
					pos: position{line: 720, col: 34, offset: 25419},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 720, col: 34, offset: 25419},
							val:        "intbitleftshift",
							ignoreCase: true,
							want:       "\"IntBitLeftShift\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 720, col: 53, offset: 25438},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 720, col: 56, offset: 25441},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 720, col: 60, offset: 25445},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 720, col: 63, offset: 25448},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 720, col: 68, offset: 25453},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 720, col: 79, offset: 25464},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 720, col: 82, offset: 25467},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 720, col: 86, offset: 25471},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 720, col: 89, offset: 25474},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 720, col: 94, offset: 25479},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 720, col: 105, offset: 25490},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 720, col: 108, offset: 25493},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitOrExpression",
			pos:  position{line: 721, col: 1, offset: 25595},
			expr: &actionExpr{
				pos: position{line: 721, col: 27, offset: 25621},
				run: (*parser).callonMathIntBitOrExpression1,
				expr: &seqExpr{
					pos: position{line: 721, col: 27, offset: 25621},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 721, col: 27, offset: 25621},
							val:        "intbitor",
							ignoreCase: true,
							want:       "\"IntBitOr\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 721, col: 39, offset: 25633},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 721, col: 42, offset: 25636},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 721, col: 46, offset: 25640},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 721, col: 49, offset: 25643},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 721, col: 54, offset: 25648},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 721, col: 65, offset: 25659},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 721, col: 68, offset: 25662},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 721, col: 72, offset: 25666},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 721, col: 75, offset: 25669},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 721, col: 80, offset: 25674},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 721, col: 91, offset: 25685},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 721, col: 94, offset: 25688},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitRightShiftExpression",
			pos:  position{line: 722, col: 1, offset: 25783},
			expr: &actionExpr{
				pos: position{line: 722, col: 35, offset: 25817},
				run: (*parser).callonMathIntBitRightShiftExpression1,
				expr: &seqExpr{
					pos: position{line: 722, col: 35, offset: 25817},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 722, col: 35, offset: 25817},
							val:        "intbitrightshift",
							ignoreCase: true,
							want:       "\"IntBitRightShift\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 722, col: 55, offset: 25837},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 722, col: 58, offset: 25840},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 722, col: 62, offset: 25844},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 722, col: 65, offset: 25847},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 722, col: 70, offset: 25852},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 722, col: 81, offset: 25863},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 722, col: 84, offset: 25866},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 722, col: 88, offset: 25870},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 722, col: 91, offset: 25873},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 722, col: 96, offset: 25878},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 722, col: 107, offset: 25889},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 722, col: 110, offset: 25892},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitXorExpression",
			pos:  position{line: 723, col: 1, offset: 25995},
			expr: &actionExpr{
				pos: position{line: 723, col: 28, offset: 26022},
				run: (*parser).callonMathIntBitXorExpression1,
				expr: &seqExpr{
					pos: position{line: 723, col: 28, offset: 26022},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 723, col: 28, offset: 26022},
							val:        "intbitxor",
							ignoreCase: true,
							want:       "\"IntBitXor\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 723, col: 41, offset: 26035},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 723, col: 44, offset: 26038},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 723, col: 48, offset: 26042},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 723, col: 51, offset: 26045},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 723, col: 56, offset: 26050},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 723, col: 67, offset: 26061},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 723, col: 70, offset: 26064},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 723, col: 74, offset: 26068},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 723, col: 77, offset: 26071},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 723, col: 82, offset: 26076},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 723, col: 93, offset: 26087},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 723, col: 96, offset: 26090},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntDivExpression",
			pos:  position{line: 724, col: 1, offset: 26186},
			expr: &actionExpr{
				pos: position{line: 724, col: 25, offset: 26210},
				run: (*parser).callonMathIntDivExpression1,
				expr: &seqExpr{
					pos: position{line: 724, col: 25, offset: 26210},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 724, col: 25, offset: 26210},
							val:        "intdiv",
							ignoreCase: true,
							want:       "\"IntDiv\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 724, col: 35, offset: 26220},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 724, col: 38, offset: 26223},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 724, col: 42, offset: 26227},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 724, col: 45, offset: 26230},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 724, col: 50, offset: 26235},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 724, col: 61, offset: 26246},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 724, col: 64, offset: 26249},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 724, col: 68, offset: 26253},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 724, col: 71, offset: 26256},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 724, col: 76, offset: 26261},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 724, col: 87, offset: 26272},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 724, col: 90, offset: 26275},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntModExpression",
			pos:  position{line: 725, col: 1, offset: 26368},
			expr: &actionExpr{
				pos: position{line: 725, col: 25, offset: 26392},
				run: (*parser).callonMathIntModExpression1,
				expr: &seqExpr{
					pos: position{line: 725, col: 25, offset: 26392},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 725, col: 25, offset: 26392},
							val:        "intmod",
							ignoreCase: true,
							want:       "\"IntMod\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 725, col: 35, offset: 26402},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 725, col: 38, offset: 26405},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 725, col: 42, offset: 26409},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 725, col: 45, offset: 26412},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 725, col: 50, offset: 26417},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 725, col: 61, offset: 26428},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 725, col: 64, offset: 26431},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 725, col: 68, offset: 26435},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 725, col: 71, offset: 26438},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 725, col: 76, offset: 26443},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 725, col: 87, offset: 26454},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 725, col: 90, offset: 26457},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntMulExpression",
			pos:  position{line: 726, col: 1, offset: 26550},
			expr: &actionExpr{
				pos: position{line: 726, col: 25, offset: 26574},
				run: (*parser).callonMathIntMulExpression1,
				expr: &seqExpr{
					pos: position{line: 726, col: 25, offset: 26574},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 726, col: 25, offset: 26574},
							val:        "intmul",
							ignoreCase: true,
							want:       "\"IntMul\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 726, col: 35, offset: 26584},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 726, col: 38, offset: 26587},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 726, col: 42, offset: 26591},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 726, col: 45, offset: 26594},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 726, col: 50, offset: 26599},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 726, col: 61, offset: 26610},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 726, col: 64, offset: 26613},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 726, col: 68, offset: 26617},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 726, col: 71, offset: 26620},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 726, col: 76, offset: 26625},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 726, col: 87, offset: 26636},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 726, col: 90, offset: 26639},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntSubExpression",
			pos:  position{line: 727, col: 1, offset: 26732},
			expr: &actionExpr{
				pos: position{line: 727, col: 25, offset: 26756},
				run: (*parser).callonMathIntSubExpression1,
				expr: &seqExpr{
					pos: position{line: 727, col: 25, offset: 26756},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 727, col: 25, offset: 26756},
							val:        "intsub",
							ignoreCase: true,
							want:       "\"IntSub\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 727, col: 35, offset: 26766},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 727, col: 38, offset: 26769},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 727, col: 42, offset: 26773},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 727, col: 45, offset: 26776},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 727, col: 50, offset: 26781},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 727, col: 61, offset: 26792},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 727, col: 64, offset: 26795},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 727, col: 68, offset: 26799},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 727, col: 71, offset: 26802},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 727, col: 76, offset: 26807},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 727, col: 87, offset: 26818},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 727, col: 90, offset: 26821},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathPowerExpression",
			pos:  position{line: 728, col: 1, offset: 26914},
			expr: &actionExpr{
				pos: position{line: 728, col: 24, offset: 26937},
				run: (*parser).callonMathPowerExpression1,
				expr: &seqExpr{
					pos: position{line: 728, col: 24, offset: 26937},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 728, col: 24, offset: 26937},
							val:        "power",
							ignoreCase: true,
							want:       "\"POWER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 728, col: 33, offset: 26946},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 728, col: 36, offset: 26949},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 728, col: 40, offset: 26953},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 728, col: 43, offset: 26956},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 728, col: 48, offset: 26961},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 728, col: 59, offset: 26972},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 728, col: 62, offset: 26975},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 728, col: 66, offset: 26979},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 728, col: 69, offset: 26982},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 728, col: 74, offset: 26987},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 728, col: 85, offset: 26998},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 728, col: 88, offset: 27001},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathLogExpression",
			pos:  position{line: 730, col: 1, offset: 27094},
			expr: &actionExpr{
				pos: position{line: 730, col: 22, offset: 27115},
				run: (*parser).callonMathLogExpression1,
				expr: &seqExpr{
					pos: position{line: 730, col: 22, offset: 27115},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 730, col: 22, offset: 27115},
							val:        "log",
							ignoreCase: true,
							want:       "\"LOG\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 730, col: 29, offset: 27122},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 730, col: 32, offset: 27125},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 730, col: 36, offset: 27129},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 730, col: 39, offset: 27132},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 730, col: 43, offset: 27136},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 730, col: 54, offset: 27147},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 730, col: 61, offset: 27154},
								expr: &actionExpr{
									pos: position{line: 730, col: 62, offset: 27155},
									run: (*parser).callonMathLogExpression11,
									expr: &seqExpr{
										pos: position{line: 730, col: 62, offset: 27155},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 730, col: 62, offset: 27155},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 730, col: 65, offset: 27158},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 730, col: 69, offset: 27162},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 730, col: 72, offset: 27165},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 730, col: 75, offset: 27168},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 730, col: 107, offset: 27200},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 730, col: 110, offset: 27203},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathNumberBinExpression",
			pos:  position{line: 733, col: 1, offset: 27325},
			expr: &actionExpr{
				pos: position{line: 733, col: 28, offset: 27352},
				run: (*parser).callonMathNumberBinExpression1,
				expr: &seqExpr{
					pos: position{line: 733, col: 28, offset: 27352},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 733, col: 28, offset: 27352},
							val:        "numberbin",
							ignoreCase: true,
							want:       "\"NumberBin\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 733, col: 41, offset: 27365},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 733, col: 44, offset: 27368},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 733, col: 48, offset: 27372},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 733, col: 51, offset: 27375},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 733, col: 55, offset: 27379},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 733, col: 66, offset: 27390},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 733, col: 73, offset: 27397},
								expr: &actionExpr{
									pos: position{line: 733, col: 74, offset: 27398},
									run: (*parser).callonMathNumberBinExpression11,
									expr: &seqExpr{
										pos: position{line: 733, col: 74, offset: 27398},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 733, col: 74, offset: 27398},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 733, col: 77, offset: 27401},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 733, col: 81, offset: 27405},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 733, col: 84, offset: 27408},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 733, col: 87, offset: 27411},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 733, col: 119, offset: 27443},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 733, col: 122, offset: 27446},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathPiExpression",
			pos:  position{line: 736, col: 1, offset: 27574},
			expr: &actionExpr{
				pos: position{line: 736, col: 21, offset: 27594},
				run: (*parser).callonMathPiExpression1,
				expr: &seqExpr{
					pos: position{line: 736, col: 21, offset: 27594},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 736, col: 21, offset: 27594},
							val:        "pi",
							ignoreCase: true,
							want:       "\"PI\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 736, col: 27, offset: 27600},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 736, col: 30, offset: 27603},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 736, col: 34, offset: 27607},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 736, col: 37, offset: 27610},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathRandExpression",
			pos:  position{line: 737, col: 1, offset: 27689},
			expr: &actionExpr{
				pos: position{line: 737, col: 23, offset: 27711},
				run: (*parser).callonMathRandExpression1,
				expr: &seqExpr{
					pos: position{line: 737, col: 23, offset: 27711},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 737, col: 23, offset: 27711},
							val:        "rand",
							ignoreCase: true,
							want:       "\"RAND\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 737, col: 31, offset: 27719},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 737, col: 34, offset: 27722},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 737, col: 38, offset: 27726},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 737, col: 41, offset: 27729},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "InFunction",
			pos:  position{line: 739, col: 1, offset: 27811},
			expr: &choiceExpr{
				pos: position{line: 739, col: 15, offset: 27825},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 739, col: 15, offset: 27825},
						run: (*parser).callonInFunction2,
						expr: &seqExpr{
							pos: position{line: 739, col: 15, offset: 27825},
							exprs: []any{
								&labeledExpr{
									pos:   position{line: 739, col: 15, offset: 27825},
									label: "ex1",
									expr: &ruleRefExpr{
										pos:  position{line: 739, col: 19, offset: 27829},
										name: "SelectProperty",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 739, col: 34, offset: 27844},
									name: "ws",
								},
								&ruleRefExpr{
									pos:  position{line: 739, col: 37, offset: 27847},
									name: "In",
								},
								&ruleRefExpr{
									pos:  position{line: 739, col: 40, offset: 27850},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 739, col: 43, offset: 27853},
									val:        "(",
									ignoreCase: false,
									want:       "\"(\"",
								},
								&ruleRefExpr{
									pos:  position{line: 739, col: 47, offset: 27857},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 739, col: 50, offset: 27860},
									label: "ex2",
									expr: &ruleRefExpr{
										pos:  position{line: 739, col: 54, offset: 27864},
										name: "SelectItem",
									},
								},
								&labeledExpr{
									pos:   position{line: 739, col: 65, offset: 27875},
									label: "others",
									expr: &zeroOrMoreExpr{
										pos: position{line: 739, col: 72, offset: 27882},
										expr: &actionExpr{
											pos: position{line: 739, col: 73, offset: 27883},
											run: (*parser).callonInFunction15,
											expr: &seqExpr{
												pos: position{line: 739, col: 73, offset: 27883},
												exprs: []any{
													&ruleRefExpr{
														pos:  position{line: 739, col: 73, offset: 27883},
														name: "ws",
													},
													&litMatcher{
														pos:        position{line: 739, col: 76, offset: 27886},
														val:        ",",
														ignoreCase: false,
														want:       "\",\"",
													},
													&ruleRefExpr{
														pos:  position{line: 739, col: 80, offset: 27890},
														name: "ws",
													},
													&labeledExpr{
														pos:   position{line: 739, col: 83, offset: 27893},
														label: "ex",
														expr: &ruleRefExpr{
															pos:  position{line: 739, col: 86, offset: 27896},
															name: "SelectItem",
														},
													},
												},
											},
										},
									},
								},
								&ruleRefExpr{
									pos:  position{line: 739, col: 118, offset: 27928},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 739, col: 121, offset: 27931},
									val:        ")",
									ignoreCase: false,
									want:       "\")\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 741, col: 5, offset: 28055},
						run: (*parser).callonInFunction24,
						expr: &seqExpr{
							pos: position{line: 741, col: 5, offset: 28055},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 741, col: 5, offset: 28055},
									val:        "(",
									ignoreCase: false,
									want:       "\"(\"",
								},
								&ruleRefExpr{
									pos:  position{line: 741, col: 9, offset: 28059},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 741, col: 12, offset: 28062},
									label: "ex1",
									expr: &ruleRefExpr{
										pos:  position{line: 741, col: 16, offset: 28066},
										name: "SelectItem",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 741, col: 27, offset: 28077},
									name: "ws",
								},
								&ruleRefExpr{
									pos:  position{line: 741, col: 30, offset: 28080},
									name: "In",
								},
								&ruleRefExpr{
									pos:  position{line: 741, col: 33, offset: 28083},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 741, col: 36, offset: 28086},
									val:        "(",
									ignoreCase: false,
									want:       "\"(\"",
								},
								&ruleRefExpr{
									pos:  position{line: 741, col: 40, offset: 28090},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 741, col: 43, offset: 28093},
									label: "ex2",
									expr: &ruleRefExpr{
										pos:  position{line: 741, col: 47, offset: 28097},
										name: "SelectItem",
									},
								},
								&labeledExpr{
									pos:   position{line: 741, col: 58, offset: 28108},
									label: "others",
									expr: &zeroOrMoreExpr{
										pos: position{line: 741, col: 65, offset: 28115},
										expr: &actionExpr{
											pos: position{line: 741, col: 66, offset: 28116},
											run: (*parser).callonInFunction39,
											expr: &seqExpr{
												pos: position{line: 741, col: 66, offset: 28116},
												exprs: []any{
													&ruleRefExpr{
														pos:  position{line: 741, col: 66, offset: 28116},
														name: "ws",
													},
													&litMatcher{
														pos:        position{line: 741, col: 69, offset: 28119},
														val:        ",",
														ignoreCase: false,
														want:       "\",\"",
													},
													&ruleRefExpr{
														pos:  position{line: 741, col: 73, offset: 28123},
														name: "ws",
													},
													&labeledExpr{
														pos:   position{line: 741, col: 76, offset: 28126},
														label: "ex",
														expr: &ruleRefExpr{
															pos:  position{line: 741, col: 79, offset: 28129},
															name: "SelectItem",
														},
													},
												},
											},
										},
									},
								},
								&ruleRefExpr{
									pos:  position{line: 741, col: 111, offset: 28161},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 741, col: 114, offset: 28164},
									val:        ")",
									ignoreCase: false,
									want:       "\")\"",
								},
								&ruleRefExpr{
									pos:  position{line: 741, col: 118, offset: 28168},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 741, col: 121, offset: 28171},
									val:        ")",
									ignoreCase: false,
									want:       "\")\"",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "AvgAggregateExpression",
			pos:  position{line: 745, col: 1, offset: 28294},
			expr: &actionExpr{
				pos: position{line: 745, col: 29, offset: 28322},
				run: (*parser).callonAvgAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 745, col: 29, offset: 28322},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 745, col: 29, offset: 28322},
							val:        "avg",
							ignoreCase: true,
							want:       "\"AVG\"i",
						},
						&litMatcher{
							pos:        position{line: 745, col: 36, offset: 28329},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 745, col: 40, offset: 28333},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 745, col: 43, offset: 28336},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 745, col: 46, offset: 28339},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 745, col: 58, offset: 28351},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 745, col: 61, offset: 28354},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "CountAggregateExpression",
			pos:  position{line: 749, col: 1, offset: 28446},
			expr: &actionExpr{
				pos: position{line: 749, col: 29, offset: 28474},
				run: (*parser).callonCountAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 749, col: 29, offset: 28474},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 749, col: 29, offset: 28474},
							val:        "count",
							ignoreCase: true,
							want:       "\"COUNT\"i",
						},
						&litMatcher{
							pos:        position{line: 749, col: 38, offset: 28483},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 749, col: 42, offset: 28487},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 749, col: 45, offset: 28490},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 749, col: 48, offset: 28493},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 749, col: 59, offset: 28504},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 749, col: 62, offset: 28507},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MaxAggregateExpression",
			pos:  position{line: 753, col: 1, offset: 28601},
			expr: &actionExpr{
				pos: position{line: 753, col: 29, offset: 28629},
				run: (*parser).callonMaxAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 753, col: 29, offset: 28629},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 753, col: 29, offset: 28629},
							val:        "max",
							ignoreCase: true,
							want:       "\"MAX\"i",
						},
						&litMatcher{
							pos:        position{line: 753, col: 36, offset: 28636},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 753, col: 40, offset: 28640},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 753, col: 43, offset: 28643},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 753, col: 46, offset: 28646},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 753, col: 57, offset: 28657},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 753, col: 60, offset: 28660},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MinAggregateExpression",
			pos:  position{line: 757, col: 1, offset: 28752},
			expr: &actionExpr{
				pos: position{line: 757, col: 29, offset: 28780},
				run: (*parser).callonMinAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 757, col: 29, offset: 28780},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 757, col: 29, offset: 28780},
							val:        "min",
							ignoreCase: true,
							want:       "\"MIN\"i",
						},
						&litMatcher{
							pos:        position{line: 757, col: 36, offset: 28787},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 757, col: 40, offset: 28791},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 757, col: 43, offset: 28794},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 757, col: 46, offset: 28797},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 757, col: 57, offset: 28808},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 757, col: 60, offset: 28811},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SumAggregateExpression",
			pos:  position{line: 761, col: 1, offset: 28903},
			expr: &actionExpr{
				pos: position{line: 761, col: 29, offset: 28931},
				run: (*parser).callonSumAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 761, col: 29, offset: 28931},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 761, col: 29, offset: 28931},
							val:        "sum",
							ignoreCase: true,
							want:       "\"SUM\"i",
						},
						&litMatcher{
							pos:        position{line: 761, col: 36, offset: 28938},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 761, col: 40, offset: 28942},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 761, col: 43, offset: 28945},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 761, col: 46, offset: 28948},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 761, col: 57, offset: 28959},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 761, col: 60, offset: 28962},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "Integer",
			pos:  position{line: 765, col: 1, offset: 29054},
			expr: &actionExpr{
				pos: position{line: 765, col: 12, offset: 29065},
				run: (*parser).callonInteger1,
				expr: &oneOrMoreExpr{
					pos: position{line: 765, col: 12, offset: 29065},
					expr: &charClassMatcher{
						pos:        position{line: 765, col: 12, offset: 29065},
						val:        "[0-9]",
						ranges:     []rune{'0', '9'},
						ignoreCase: false,
						inverted:   false,
					},
				},
			},
		},
		{
			name: "StringCharacter",
			pos:  position{line: 769, col: 1, offset: 29117},
			expr: &choiceExpr{
				pos: position{line: 769, col: 20, offset: 29136},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 769, col: 20, offset: 29136},
						run: (*parser).callonStringCharacter2,
						expr: &seqExpr{
							pos: position{line: 769, col: 20, offset: 29136},
							exprs: []any{
								&notExpr{
									pos: position{line: 769, col: 20, offset: 29136},
									expr: &choiceExpr{
										pos: position{line: 769, col: 22, offset: 29138},
										alternatives: []any{
											&litMatcher{
												pos:        position{line: 769, col: 22, offset: 29138},
												val:        "\"",
												ignoreCase: false,
												want:       "\"\\\"\"",
											},
											&litMatcher{
												pos:        position{line: 769, col: 28, offset: 29144},
												val:        "\\",
												ignoreCase: false,
												want:       "\"\\\\\"",
											},
										},
									},
								},
								&anyMatcher{
									line: 769, col: 34, offset: 29150,
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 770, col: 5, offset: 29187},
						run: (*parser).callonStringCharacter9,
						expr: &seqExpr{
							pos: position{line: 770, col: 5, offset: 29187},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 770, col: 5, offset: 29187},
									val:        "\\",
									ignoreCase: false,
									want:       "\"\\\\\"",
								},
								&labeledExpr{
									pos:   position{line: 770, col: 10, offset: 29192},
									label: "seq",
									expr: &ruleRefExpr{
										pos:  position{line: 770, col: 14, offset: 29196},
										name: "EscapeSequenceCharacter",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "EscapeSequenceCharacter",
			pos:  position{line: 772, col: 1, offset: 29241},
			expr: &labeledExpr{
				pos:   position{line: 772, col: 28, offset: 29268},
				label: "char",
				expr: &ruleRefExpr{
					pos:  position{line: 772, col: 33, offset: 29273},
					name: "EscapeCharacter",
				},
			},
		},
		{
			name: "EscapeCharacter",
			pos:  position{line: 774, col: 1, offset: 29290},
			expr: &choiceExpr{
				pos: position{line: 774, col: 20, offset: 29309},
				alternatives: []any{
					&litMatcher{
						pos:        position{line: 774, col: 20, offset: 29309},
						val:        "'",
						ignoreCase: false,
						want:       "\"'\"",
					},
					&litMatcher{
						pos:        position{line: 775, col: 5, offset: 29317},
						val:        "\"",
						ignoreCase: false,
						want:       "\"\\\"\"",
					},
					&litMatcher{
						pos:        position{line: 776, col: 5, offset: 29325},
						val:        "\\",
						ignoreCase: false,
						want:       "\"\\\\\"",
					},
					&actionExpr{
						pos: position{line: 777, col: 5, offset: 29334},
						run: (*parser).callonEscapeCharacter5,
						expr: &litMatcher{
							pos:        position{line: 777, col: 5, offset: 29334},
							val:        "b",
							ignoreCase: false,
							want:       "\"b\"",
						},
					},
					&actionExpr{
						pos: position{line: 778, col: 5, offset: 29363},
						run: (*parser).callonEscapeCharacter7,
						expr: &litMatcher{
							pos:        position{line: 778, col: 5, offset: 29363},
							val:        "f",
							ignoreCase: false,
							want:       "\"f\"",
						},
					},
					&actionExpr{
						pos: position{line: 779, col: 5, offset: 29392},
						run: (*parser).callonEscapeCharacter9,
						expr: &litMatcher{
							pos:        position{line: 779, col: 5, offset: 29392},
							val:        "n",
							ignoreCase: false,
							want:       "\"n\"",
						},
					},
					&actionExpr{
						pos: position{line: 780, col: 5, offset: 29421},
						run: (*parser).callonEscapeCharacter11,
						expr: &litMatcher{
							pos:        position{line: 780, col: 5, offset: 29421},
							val:        "r",
							ignoreCase: false,
							want:       "\"r\"",
						},
					},
					&actionExpr{
						pos: position{line: 781, col: 5, offset: 29450},
						run: (*parser).callonEscapeCharacter13,
						expr: &litMatcher{
							pos:        position{line: 781, col: 5, offset: 29450},
							val:        "t",
							ignoreCase: false,
							want:       "\"t\"",
						},
					},
				},
			},
		},
		{
			name: "non_escape_character",
			pos:  position{line: 783, col: 1, offset: 29476},
			expr: &actionExpr{
				pos: position{line: 783, col: 25, offset: 29500},
				run: (*parser).callonnon_escape_character1,
				expr: &seqExpr{
					pos: position{line: 783, col: 25, offset: 29500},
					exprs: []any{
						&notExpr{
							pos: position{line: 783, col: 25, offset: 29500},
							expr: &ruleRefExpr{
								pos:  position{line: 783, col: 27, offset: 29502},
								name: "escape_character",
							},
						},
						&labeledExpr{
							pos:   position{line: 783, col: 45, offset: 29520},
							label: "char",
							expr: &anyMatcher{
								line: 783, col: 50, offset: 29525,
							},
						},
					},
				},
			},
		},
		{
			name: "ws",
			pos:  position{line: 786, col: 1, offset: 29564},
			expr: &zeroOrMoreExpr{
				pos: position{line: 786, col: 7, offset: 29570},
				expr: &charClassMatcher{
					pos:        position{line: 786, col: 7, offset: 29570},
					val:        "[ \\t\\n\\r]",
					chars:      []rune{' ', '\t', '\n', '\r'},
					ignoreCase: false,
					inverted:   false,
				},
			},
		},
		{
			name: "wss",
			pos:  position{line: 788, col: 1, offset: 29582},
			expr: &oneOrMoreExpr{
				pos: position{line: 788, col: 8, offset: 29589},
				expr: &charClassMatcher{
					pos:        position{line: 788, col: 8, offset: 29589},
					val:        "[ \\t\\n\\r]",
					chars:      []rune{' ', '\t', '\n', '\r'},
					ignoreCase: false,
					inverted:   false,
				},
			},
		},
		{
			name: "EOF",
			pos:  position{line: 790, col: 1, offset: 29601},
			expr: &notExpr{
				pos: position{line: 790, col: 8, offset: 29608},
				expr: &anyMatcher{
					line: 790, col: 9, offset: 29609,
				},
			},
		},
	},
}

func (c *current) onInput1(selectStmt any) (any, error) {
	return selectStmt, nil
}

func (p *parser) callonInput1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInput1(stack["selectStmt"])
}

func (c *current) onSelectStmt22(join any) (any, error) {
	return join, nil
}

func (p *parser) callonSelectStmt22() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt22(stack["join"])
}

func (c *current) onSelectStmt30(condition any) (any, error) {
	return condition, nil
}

func (p *parser) callonSelectStmt30() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt30(stack["condition"])
}

func (c *current) onSelectStmt39(columns any) (any, error) {
	return columns, nil
}

func (p *parser) callonSelectStmt39() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt39(stack["columns"])
}

func (c *current) onSelectStmt48(order any) (any, error) {
	return order, nil
}

func (p *parser) callonSelectStmt48() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt48(stack["order"])
}

func (c *current) onSelectStmt55(offset any) (any, error) {
	return offset, nil
}

func (p *parser) callonSelectStmt55() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt55(stack["offset"])
}

func (c *current) onSelectStmt1(distinctClause, topClause, columns, fromClause, joinClauses, whereClause, groupByClause, orderByClause, offsetClause any) (any, error) {
	return makeSelectStmt(columns, fromClause, joinClauses, whereClause,
		distinctClause, topClause, groupByClause, orderByClause, offsetClause)
}

func (p *parser) callonSelectStmt1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt1(stack["distinctClause"], stack["topClause"], stack["columns"], stack["fromClause"], stack["joinClauses"], stack["whereClause"], stack["groupByClause"], stack["orderByClause"], stack["offsetClause"])
}

func (c *current) onTopClause1(count any) (any, error) {
	return count, nil
}

func (p *parser) callonTopClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTopClause1(stack["count"])
}

func (c *current) onFromClause9(column any) (any, error) {
	return column, nil
}

func (p *parser) callonFromClause9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFromClause9(stack["column"])
}

func (c *current) onFromClause2(table, selectItem any) (any, error) {
	tableTyped := table.(parsers.Table)

	if selectItem != nil {
		tableTyped.SelectItem = selectItem.(parsers.SelectItem)
		tableTyped.IsInSelect = true
	}

	return tableTyped, nil
}

func (p *parser) callonFromClause2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFromClause2(stack["table"], stack["selectItem"])
}

func (c *current) onFromClause16(column any) (any, error) {
	tableSelectItem := column.(parsers.SelectItem)
	table := parsers.Table{
		Value:      tableSelectItem.Alias,
		SelectItem: tableSelectItem,
	}
	return table, nil
}

func (p *parser) callonFromClause16() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFromClause16(stack["column"])
}

func (c *current) onFromClause22(subQuery any) (any, error) {
	subQueryTyped := subQuery.(parsers.SelectItem)
	table := parsers.Table{
		Value:      subQueryTyped.Alias,
		SelectItem: subQueryTyped,
	}
	return table, nil
}

func (p *parser) callonFromClause22() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFromClause22(stack["subQuery"])
}

func (c *current) onSubQuery5(exists any) (any, error) {
	return exists, nil
}

func (p *parser) callonSubQuery5() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubQuery5(stack["exists"])
}

func (c *current) onSubQuery1(exists, selectStmt any) (any, error) {
	if selectStatement, isGoodValue := selectStmt.(parsers.SelectStmt); isGoodValue {
		selectStatement.Exists = exists != nil
		return selectStatement, nil
	}

	return selectStmt, nil
}

func (p *parser) callonSubQuery1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubQuery1(stack["exists"], stack["selectStmt"])
}

func (c *current) onSubQuerySelectItem7(alias any) (any, error) {
	return alias, nil
}

func (p *parser) callonSubQuerySelectItem7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubQuerySelectItem7(stack["alias"])
}

func (c *current) onSubQuerySelectItem1(subQuery, asClause any) (any, error) {
	selectItem := parsers.SelectItem{
		Type:  parsers.SelectItemTypeSubQuery,
		Value: subQuery,
	}

	if tableName, isString := asClause.(string); isString {
		selectItem.Alias = tableName
	}

	return selectItem, nil
}

func (p *parser) callonSubQuerySelectItem1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubQuerySelectItem1(stack["subQuery"], stack["asClause"])
}

func (c *current) onJoinClause2(table, column any) (any, error) {
	return makeJoin(table, column)
}

func (p *parser) callonJoinClause2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onJoinClause2(stack["table"], stack["column"])
}

func (c *current) onJoinClause13(subQuery any) (any, error) {
	return makeJoin(nil, subQuery)
}

func (p *parser) callonJoinClause13() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onJoinClause13(stack["subQuery"])
}

func (c *current) onOffsetClause1(offset, limit any) (any, error) {
	return []interface{}{offset.(parsers.Constant).Value, limit.(parsers.Constant).Value}, nil
}

func (p *parser) callonOffsetClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOffsetClause1(stack["offset"], stack["limit"])
}

func (c *current) onSelectAsterisk1() (any, error) {
	selectItem, _ := makeSelectItem("c", make([]interface{}, 0), parsers.SelectItemTypeField)
	selectItem.IsTopLevel = true
	return makeColumnList(selectItem, make([]interface{}, 0))
}

func (p *parser) callonSelectAsterisk1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectAsterisk1()
}

func (c *current) onColumnList7(coll any) (any, error) {
	return coll, nil
}

func (p *parser) callonColumnList7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onColumnList7(stack["coll"])
}

func (c *current) onColumnList1(column, other_columns any) (any, error) {
	return makeColumnList(column, other_columns)
}

func (p *parser) callonColumnList1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onColumnList1(stack["column"], stack["other_columns"])
}

func (c *current) onSelectValueSpec1(column any) (any, error) {
	selectItem := column.(parsers.SelectItem)
	selectItem.IsTopLevel = true
	return makeColumnList(selectItem, make([]interface{}, 0))
}

func (p *parser) callonSelectValueSpec1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectValueSpec1(stack["column"])
}

func (c *current) onTableName1(key any) (any, error) {
	return parsers.Table{Value: key.(string)}, nil
}

func (p *parser) callonTableName1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTableName1(stack["key"])
}

func (c *current) onSelectArray1(columns any) (any, error) {
	return makeSelectArray(columns)
}

func (p *parser) callonSelectArray1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectArray1(stack["columns"])
}

func (c *current) onSelectObject11(coll any) (any, error) {
	return coll, nil
}

func (p *parser) callonSelectObject11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObject11(stack["coll"])
}

func (c *current) onSelectObject2(field, other_fields any) (any, error) {
	return makeSelectObject(field, other_fields)
}

func (p *parser) callonSelectObject2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObject2(stack["field"], stack["other_fields"])
}

func (c *current) onSelectObject20() (any, error) {
	return parsers.SelectItem{
		SelectItems: []parsers.SelectItem{},
		Type:        parsers.SelectItemTypeObject,
	}, nil
}

func (p *parser) callonSelectObject20() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObject20()
}

func (c *current) onSelectObjectField6(key any) (any, error) {
	return key, nil
}

func (p *parser) callonSelectObjectField6() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObjectField6(stack["key"])
}

func (c *current) onSelectObjectField1(name, selectItem any) (any, error) {
	item := selectItem.(parsers.SelectItem)
	item.Alias = name.(string)
	return item, nil
}

func (p *parser) callonSelectObjectField1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObjectField1(stack["name"], stack["selectItem"])
}

func (c *current) onSelectProperty1(name, path any) (any, error) {
	return makeSelectItem(name, path, parsers.SelectItemTypeField)
}

func (p *parser) callonSelectProperty1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectProperty1(stack["name"], stack["path"])
}

func (c *current) onSelectItem1(selectItem, asClause any) (any, error) {
	var itemResult parsers.SelectItem
	switch typedValue := selectItem.(type) {
	case parsers.SelectItem:
		itemResult = typedValue
	case parsers.Constant:
		itemResult = parsers.SelectItem{
			Type:  parsers.SelectItemTypeConstant,
			Value: typedValue,
		}
	case parsers.FunctionCall:
		itemResult = parsers.SelectItem{
			Type:  parsers.SelectItemTypeFunctionCall,
			Value: typedValue,
		}
	}

	if aliasValue, ok := asClause.(string); ok {
		itemResult.Alias = aliasValue
	}

	return itemResult, nil
}

func (p *parser) callonSelectItem1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectItem1(stack["selectItem"], stack["asClause"])
}

func (c *current) onAsClause1(alias any) (any, error) {
	return alias, nil
}

func (p *parser) callonAsClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAsClause1(stack["alias"])
}

func (c *current) onDotFieldAccess1(id any) (any, error) {
	return id, nil
}

func (p *parser) callonDotFieldAccess1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onDotFieldAccess1(stack["id"])
}

func (c *current) onArrayFieldAccess2(id any) (any, error) {
	return id, nil
}

func (p *parser) callonArrayFieldAccess2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayFieldAccess2(stack["id"])
}

func (c *current) onArrayFieldAccess8(id any) (any, error) {
	return strconv.Itoa(id.(int)), nil
}

func (p *parser) callonArrayFieldAccess8() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayFieldAccess8(stack["id"])
}

func (c *current) onArrayFieldAccess14(id any) (any, error) {
	return id.(parsers.Constant).Value.(string), nil
}

func (p *parser) callonArrayFieldAccess14() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayFieldAccess14(stack["id"])
}

func (c *current) onIdentifier1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonIdentifier1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIdentifier1()
}

func (c *current) onCondition1(expression any) (any, error) {
	return expression, nil
}

func (p *parser) callonCondition1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onCondition1(stack["expression"])
}

func (c *current) onOrExpression7(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonOrExpression7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrExpression7(stack["ex"])
}

func (c *current) onOrExpression1(ex1, ex2 any) (any, error) {
	return combineExpressions(ex1, ex2, parsers.LogicalExpressionTypeOr)
}

func (p *parser) callonOrExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onAndExpression7(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonAndExpression7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAndExpression7(stack["ex"])
}

func (c *current) onAndExpression1(ex1, ex2 any) (any, error) {
	return combineExpressions(ex1, ex2, parsers.LogicalExpressionTypeAnd)
}

func (p *parser) callonAndExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAndExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onComparisonExpression2(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression2(stack["ex"])
}

func (c *current) onComparisonExpression10(left, op, right any) (any, error) {
	return parsers.ComparisonExpression{Left: left, Right: right, Operation: op.(string)}, nil
}

func (p *parser) callonComparisonExpression10() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression10(stack["left"], stack["op"], stack["right"])
}

func (c *current) onComparisonExpression20(inv, ex any) (any, error) {
	if inv != nil {
		ex1 := ex.(parsers.SelectItem)
		ex1.Invert = true
		return ex1, nil
	}
	return ex, nil
}

func (p *parser) callonComparisonExpression20() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression20(stack["inv"], stack["ex"])
}

func (c *current) onComparisonExpression29(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression29() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression29(stack["ex"])
}

func (c *current) onOrderByClause9(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonOrderByClause9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderByClause9(stack["ex"])
}

func (c *current) onOrderByClause1(ex1, others any) (any, error) {
	return makeOrderByClause(ex1, others)
}

func (p *parser) callonOrderByClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderByClause1(stack["ex1"], stack["others"])
}

func (c *current) onOrderExpression1(field, order any) (any, error) {
	return makeOrderExpression(field, order)
}

func (p *parser) callonOrderExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderExpression1(stack["field"], stack["order"])
}

func (c *current) onOrderDirection1() (any, error) {
	if strings.EqualFold(string(c.text), "DESC") {
		return parsers.OrderDirectionDesc, nil
	}

	return parsers.OrderDirectionAsc, nil
}

func (p *parser) callonOrderDirection1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderDirection1()
}

func (c *current) onComparisonOperator1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonComparisonOperator1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonOperator1()
}

func (c *current) onParameterConstant1() (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeParameterConstant, Value: string(c.text)}, nil
}

func (p *parser) callonParameterConstant1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onParameterConstant1()
}

func (c *current) onNullConstant1() (any, error) {
	return parsers.Constant{Value: nil}, nil
}

func (p *parser) callonNullConstant1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onNullConstant1()
}

func (c *current) onIntegerLiteral1(number any) (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeInteger, Value: number.(int)}, nil
}

func (p *parser) callonIntegerLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIntegerLiteral1(stack["number"])
}

func (c *current) onStringLiteral1(chars any) (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeString, Value: joinStrings(chars.([]interface{}))}, nil
}

func (p *parser) callonStringLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringLiteral1(stack["chars"])
}

func (c *current) onFloatLiteral1() (any, error) {
	floatValue, _ := strconv.ParseFloat(string(c.text), 64)
	return parsers.Constant{Type: parsers.ConstantTypeFloat, Value: floatValue}, nil
}

func (p *parser) callonFloatLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFloatLiteral1()
}

func (c *current) onBooleanLiteral1() (any, error) {
	boolValue, _ := strconv.ParseBool(string(c.text))
	return parsers.Constant{Type: parsers.ConstantTypeBoolean, Value: boolValue}, nil
}

func (p *parser) callonBooleanLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onBooleanLiteral1()
}

func (c *current) onUpperExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallUpper, []interface{}{ex})
}

func (p *parser) callonUpperExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onUpperExpression1(stack["ex"])
}

func (c *current) onLowerExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLower, []interface{}{ex})
}

func (p *parser) callonLowerExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLowerExpression1(stack["ex"])
}

func (c *current) onStringEqualsExpression17(boolean any) (any, error) {
	return boolean, nil
}

func (p *parser) callonStringEqualsExpression17() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringEqualsExpression17(stack["boolean"])
}

func (c *current) onStringEqualsExpression1(ex1, ex2, ignoreCase any) (any, error) {
	return createFunctionCall(parsers.FunctionCallStringEquals, []interface{}{ex1, ex2, ignoreCase})
}

func (p *parser) callonStringEqualsExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringEqualsExpression1(stack["ex1"], stack["ex2"], stack["ignoreCase"])
}

func (c *current) onToStringExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallToString, []interface{}{ex})
}

func (p *parser) callonToStringExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onToStringExpression1(stack["ex"])
}

func (c *current) onConcatExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonConcatExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onConcatExpression11(stack["ex"])
}

func (c *current) onConcatExpression1(ex1, others any) (any, error) {
	arguments := append([]interface{}{ex1}, others.([]interface{})...)
	return createFunctionCall(parsers.FunctionCallConcat, arguments)
}

func (p *parser) callonConcatExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onConcatExpression1(stack["ex1"], stack["others"])
}

func (c *current) onLeftExpression1(ex, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLeft, []interface{}{ex, length})
}

func (p *parser) callonLeftExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLeftExpression1(stack["ex"], stack["length"])
}

func (c *current) onLengthExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLength, []interface{}{ex})
}

func (p *parser) callonLengthExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLengthExpression1(stack["ex"])
}

func (c *current) onLTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLTrim, []interface{}{ex})
}

func (p *parser) callonLTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLTrimExpression1(stack["ex"])
}

func (c *current) onReplaceExpression1(ex1, ex2, ex3 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReplace, []interface{}{ex1, ex2, ex3})
}

func (p *parser) callonReplaceExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReplaceExpression1(stack["ex1"], stack["ex2"], stack["ex3"])
}

func (c *current) onReplicateExpression1(ex1, ex2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReplicate, []interface{}{ex1, ex2})
}

func (p *parser) callonReplicateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReplicateExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onReverseExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReverse, []interface{}{ex})
}

func (p *parser) callonReverseExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReverseExpression1(stack["ex"])
}

func (c *current) onRightExpression1(ex, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallRight, []interface{}{ex, length})
}

func (p *parser) callonRightExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onRightExpression1(stack["ex"], stack["length"])
}

func (c *current) onRTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallRTrim, []interface{}{ex})
}

func (p *parser) callonRTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onRTrimExpression1(stack["ex"])
}

func (c *current) onSubstringExpression1(ex, startPos, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSubstring, []interface{}{ex, startPos, length})
}

func (p *parser) callonSubstringExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubstringExpression1(stack["ex"], stack["startPos"], stack["length"])
}

func (c *current) onTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallTrim, []interface{}{ex})
}

func (p *parser) callonTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTrimExpression1(stack["ex"])
}

func (c *current) onThreeArgumentStringFunctionExpression18(boolean any) (any, error) {
	return boolean, nil
}

func (p *parser) callonThreeArgumentStringFunctionExpression18() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunctionExpression18(stack["boolean"])
}

func (c *current) onThreeArgumentStringFunctionExpression1(function, ex1, ex2, ignoreCase any) (any, error) {
	var functionType parsers.FunctionCallType

	lowerFunction := strings.ToUpper(function.(string))
	switch lowerFunction {
	case "CONTAINS":
		functionType = parsers.FunctionCallContains
	case "ENDSWITH":
		functionType = parsers.FunctionCallEndsWith
	case "STARTSWITH":
		functionType = parsers.FunctionCallStartsWith
	case "INDEX_OF":
		functionType = parsers.FunctionCallIndexOf
	}

	return createFunctionCall(functionType, []interface{}{ex1, ex2, ignoreCase})
}

func (p *parser) callonThreeArgumentStringFunctionExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunctionExpression1(stack["function"], stack["ex1"], stack["ex2"], stack["ignoreCase"])
}

func (c *current) onThreeArgumentStringFunction1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonThreeArgumentStringFunction1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunction1()
}

func (c *current) onIsDefined1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsDefined, []interface{}{ex})
}

func (p *parser) callonIsDefined1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsDefined1(stack["ex"])
}

func (c *current) onIsArray1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsArray, []interface{}{ex})
}

func (p *parser) callonIsArray1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsArray1(stack["ex"])
}

func (c *current) onIsBool1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsBool, []interface{}{ex})
}

func (p *parser) callonIsBool1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsBool1(stack["ex"])
}

func (c *current) onIsFiniteNumber1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsFiniteNumber, []interface{}{ex})
}

func (p *parser) callonIsFiniteNumber1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsFiniteNumber1(stack["ex"])
}

func (c *current) onIsInteger1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsInteger, []interface{}{ex})
}

func (p *parser) callonIsInteger1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsInteger1(stack["ex"])
}

func (c *current) onIsNull1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsNull, []interface{}{ex})
}

func (p *parser) callonIsNull1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsNull1(stack["ex"])
}

func (c *current) onIsNumber1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsNumber, []interface{}{ex})
}

func (p *parser) callonIsNumber1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsNumber1(stack["ex"])
}

func (c *current) onIsObject1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsObject, []interface{}{ex})
}

func (p *parser) callonIsObject1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsObject1(stack["ex"])
}

func (c *current) onIsPrimitive1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsPrimitive, []interface{}{ex})
}

func (p *parser) callonIsPrimitive1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsPrimitive1(stack["ex"])
}

func (c *current) onIsString1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsString, []interface{}{ex})
}

func (p *parser) callonIsString1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsString1(stack["ex"])
}

func (c *current) onArrayConcatExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArrayConcatExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayConcatExpression11(stack["ex"])
}

func (c *current) onArrayConcatExpression1(arrays, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayConcat, append([]interface{}{arrays}, others.([]interface{})...))
}

func (p *parser) callonArrayConcatExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayConcatExpression1(stack["arrays"], stack["others"])
}

func (c *current) onArrayContainsExpression16(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArrayContainsExpression16() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsExpression16(stack["ex"])
}

func (c *current) onArrayContainsExpression1(array, item, partialMatch any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayContains, []interface{}{array, item, partialMatch})
}

func (p *parser) callonArrayContainsExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsExpression1(stack["array"], stack["item"], stack["partialMatch"])
}

func (c *current) onArrayContainsAnyExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArrayContainsAnyExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsAnyExpression11(stack["ex"])
}

func (c *current) onArrayContainsAnyExpression1(array, items any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayContainsAny, append([]interface{}{array}, items.([]interface{})...))
}

func (p *parser) callonArrayContainsAnyExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsAnyExpression1(stack["array"], stack["items"])
}

func (c *current) onArrayContainsAllExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArrayContainsAllExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsAllExpression11(stack["ex"])
}

func (c *current) onArrayContainsAllExpression1(array, items any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayContainsAll, append([]interface{}{array}, items.([]interface{})...))
}

func (p *parser) callonArrayContainsAllExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsAllExpression1(stack["array"], stack["items"])
}

func (c *current) onArrayLengthExpression1(array any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayLength, []interface{}{array})
}

func (p *parser) callonArrayLengthExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayLengthExpression1(stack["array"])
}

func (c *current) onArraySliceExpression16(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArraySliceExpression16() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArraySliceExpression16(stack["ex"])
}

func (c *current) onArraySliceExpression1(array, start, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArraySlice, []interface{}{array, start, length})
}

func (p *parser) callonArraySliceExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArraySliceExpression1(stack["array"], stack["start"], stack["length"])
}

func (c *current) onSetIntersectExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSetIntersect, []interface{}{set1, set2})
}

func (p *parser) callonSetIntersectExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSetIntersectExpression1(stack["set1"], stack["set2"])
}

func (c *current) onSetUnionExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSetUnion, []interface{}{set1, set2})
}

func (p *parser) callonSetUnionExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSetUnionExpression1(stack["set1"], stack["set2"])
}

func (c *current) onIifExpression1(condition, trueValue, falseValue any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIif, []interface{}{condition, trueValue, falseValue})
}

func (p *parser) callonIifExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIifExpression1(stack["condition"], stack["trueValue"], stack["falseValue"])
}

func (c *current) onMathAbsExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAbs, []interface{}{ex})
}

func (p *parser) callonMathAbsExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAbsExpression1(stack["ex"])
}

func (c *current) onMathAcosExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAcos, []interface{}{ex})
}

func (p *parser) callonMathAcosExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAcosExpression1(stack["ex"])
}

func (c *current) onMathAsinExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAsin, []interface{}{ex})
}

func (p *parser) callonMathAsinExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAsinExpression1(stack["ex"])
}

func (c *current) onMathAtanExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAtan, []interface{}{ex})
}

func (p *parser) callonMathAtanExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAtanExpression1(stack["ex"])
}

func (c *current) onMathCeilingExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathCeiling, []interface{}{ex})
}

func (p *parser) callonMathCeilingExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathCeilingExpression1(stack["ex"])
}

func (c *current) onMathCosExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathCos, []interface{}{ex})
}

func (p *parser) callonMathCosExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathCosExpression1(stack["ex"])
}

func (c *current) onMathCotExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathCot, []interface{}{ex})
}

func (p *parser) callonMathCotExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathCotExpression1(stack["ex"])
}

func (c *current) onMathDegreesExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathDegrees, []interface{}{ex})
}

func (p *parser) callonMathDegreesExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathDegreesExpression1(stack["ex"])
}

func (c *current) onMathExpExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathExp, []interface{}{ex})
}

func (p *parser) callonMathExpExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathExpExpression1(stack["ex"])
}

func (c *current) onMathFloorExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathFloor, []interface{}{ex})
}

func (p *parser) callonMathFloorExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathFloorExpression1(stack["ex"])
}

func (c *current) onMathIntBitNotExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitNot, []interface{}{ex})
}

func (p *parser) callonMathIntBitNotExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitNotExpression1(stack["ex"])
}

func (c *current) onMathLog10Expression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathLog10, []interface{}{ex})
}

func (p *parser) callonMathLog10Expression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathLog10Expression1(stack["ex"])
}

func (c *current) onMathRadiansExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathRadians, []interface{}{ex})
}

func (p *parser) callonMathRadiansExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathRadiansExpression1(stack["ex"])
}

func (c *current) onMathRoundExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathRound, []interface{}{ex})
}

func (p *parser) callonMathRoundExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathRoundExpression1(stack["ex"])
}

func (c *current) onMathSignExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSign, []interface{}{ex})
}

func (p *parser) callonMathSignExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSignExpression1(stack["ex"])
}

func (c *current) onMathSinExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSin, []interface{}{ex})
}

func (p *parser) callonMathSinExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSinExpression1(stack["ex"])
}

func (c *current) onMathSqrtExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSqrt, []interface{}{ex})
}

func (p *parser) callonMathSqrtExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSqrtExpression1(stack["ex"])
}

func (c *current) onMathSquareExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSquare, []interface{}{ex})
}

func (p *parser) callonMathSquareExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSquareExpression1(stack["ex"])
}

func (c *current) onMathTanExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathTan, []interface{}{ex})
}

func (p *parser) callonMathTanExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathTanExpression1(stack["ex"])
}

func (c *current) onMathTruncExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathTrunc, []interface{}{ex})
}

func (p *parser) callonMathTruncExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathTruncExpression1(stack["ex"])
}

func (c *current) onMathAtn2Expression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAtn2, []interface{}{set1, set2})
}

func (p *parser) callonMathAtn2Expression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAtn2Expression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntAddExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntAdd, []interface{}{set1, set2})
}

func (p *parser) callonMathIntAddExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntAddExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitAndExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitAnd, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitAndExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitAndExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitLeftShiftExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitLeftShift, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitLeftShiftExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitLeftShiftExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitOrExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitOr, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitOrExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitOrExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitRightShiftExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitRightShift, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitRightShiftExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitRightShiftExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitXorExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitXor, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitXorExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitXorExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntDivExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntDiv, []interface{}{set1, set2})
}

func (p *parser) callonMathIntDivExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntDivExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntModExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntMod, []interface{}{set1, set2})
}

func (p *parser) callonMathIntModExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntModExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntMulExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntMul, []interface{}{set1, set2})
}

func (p *parser) callonMathIntMulExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntMulExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntSubExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntSub, []interface{}{set1, set2})
}

func (p *parser) callonMathIntSubExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntSubExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathPowerExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathPower, []interface{}{set1, set2})
}

func (p *parser) callonMathPowerExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathPowerExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathLogExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonMathLogExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathLogExpression11(stack["ex"])
}

func (c *current) onMathLogExpression1(ex1, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathLog, append([]interface{}{ex1}, others.([]interface{})...))
}

func (p *parser) callonMathLogExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathLogExpression1(stack["ex1"], stack["others"])
}

func (c *current) onMathNumberBinExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonMathNumberBinExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathNumberBinExpression11(stack["ex"])
}

func (c *current) onMathNumberBinExpression1(ex1, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathNumberBin, append([]interface{}{ex1}, others.([]interface{})...))
}

func (p *parser) callonMathNumberBinExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathNumberBinExpression1(stack["ex1"], stack["others"])
}

func (c *current) onMathPiExpression1() (any, error) {
	return createFunctionCall(parsers.FunctionCallMathPi, []interface{}{})
}

func (p *parser) callonMathPiExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathPiExpression1()
}

func (c *current) onMathRandExpression1() (any, error) {
	return createFunctionCall(parsers.FunctionCallMathRand, []interface{}{})
}

func (p *parser) callonMathRandExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathRandExpression1()
}

func (c *current) onInFunction15(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonInFunction15() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction15(stack["ex"])
}

func (c *current) onInFunction2(ex1, ex2, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIn, append([]interface{}{ex1, ex2}, others.([]interface{})...))
}

func (p *parser) callonInFunction2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction2(stack["ex1"], stack["ex2"], stack["others"])
}

func (c *current) onInFunction39(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonInFunction39() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction39(stack["ex"])
}

func (c *current) onInFunction24(ex1, ex2, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIn, append([]interface{}{ex1, ex2}, others.([]interface{})...))
}

func (p *parser) callonInFunction24() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction24(stack["ex1"], stack["ex2"], stack["others"])
}

func (c *current) onAvgAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateAvg, []interface{}{ex})
}

func (p *parser) callonAvgAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAvgAggregateExpression1(stack["ex"])
}

func (c *current) onCountAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateCount, []interface{}{ex})
}

func (p *parser) callonCountAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onCountAggregateExpression1(stack["ex"])
}

func (c *current) onMaxAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateMax, []interface{}{ex})
}

func (p *parser) callonMaxAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMaxAggregateExpression1(stack["ex"])
}

func (c *current) onMinAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateMin, []interface{}{ex})
}

func (p *parser) callonMinAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMinAggregateExpression1(stack["ex"])
}

func (c *current) onSumAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateSum, []interface{}{ex})
}

func (p *parser) callonSumAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSumAggregateExpression1(stack["ex"])
}

func (c *current) onInteger1() (any, error) {
	return strconv.Atoi(string(c.text))
}

func (p *parser) callonInteger1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInteger1()
}

func (c *current) onStringCharacter2() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonStringCharacter2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringCharacter2()
}

func (c *current) onStringCharacter9(seq any) (any, error) {
	return seq, nil
}

func (p *parser) callonStringCharacter9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringCharacter9(stack["seq"])
}

func (c *current) onEscapeCharacter5() (any, error) {
	return "\b", nil
}

func (p *parser) callonEscapeCharacter5() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter5()
}

func (c *current) onEscapeCharacter7() (any, error) {
	return "\f", nil
}

func (p *parser) callonEscapeCharacter7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter7()
}

func (c *current) onEscapeCharacter9() (any, error) {
	return "\n", nil
}

func (p *parser) callonEscapeCharacter9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter9()
}

func (c *current) onEscapeCharacter11() (any, error) {
	return "\r", nil
}

func (p *parser) callonEscapeCharacter11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter11()
}

func (c *current) onEscapeCharacter13() (any, error) {
	return "\t", nil
}

func (p *parser) callonEscapeCharacter13() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter13()
}

func (c *current) onnon_escape_character1(char any) (any, error) {
	return string(c.text), nil
}

func (p *parser) callonnon_escape_character1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onnon_escape_character1(stack["char"])
}

var (
	// errNoRule is returned when the grammar to parse has no rule.
	errNoRule = errors.New("grammar has no rule")

	// errInvalidEntrypoint is returned when the specified entrypoint rule
	// does not exit.
	errInvalidEntrypoint = errors.New("invalid entrypoint")

	// errInvalidEncoding is returned when the source is not properly
	// utf8-encoded.
	errInvalidEncoding = errors.New("invalid encoding")

	// errMaxExprCnt is used to signal that the maximum number of
	// expressions have been parsed.
	errMaxExprCnt = errors.New("max number of expressions parsed")
)

// Option is a function that can set an option on the parser. It returns
// the previous setting as an Option.
type Option func(*parser) Option

// MaxExpressions creates an Option to stop parsing after the provided
// number of expressions have been parsed, if the value is 0 then the parser will
// parse for as many steps as needed (possibly an infinite number).
//
// The default for maxExprCnt is 0.
func MaxExpressions(maxExprCnt uint64) Option {
	return func(p *parser) Option {
		oldMaxExprCnt := p.maxExprCnt
		p.maxExprCnt = maxExprCnt
		return MaxExpressions(oldMaxExprCnt)
	}
}

// Entrypoint creates an Option to set the rule name to use as entrypoint.
// The rule name must have been specified in the -alternate-entrypoints
// if generating the parser with the -optimize-grammar flag, otherwise
// it may have been optimized out. Passing an empty string sets the
// entrypoint to the first rule in the grammar.
//
// The default is to start parsing at the first rule in the grammar.
func Entrypoint(ruleName string) Option {
	return func(p *parser) Option {
		oldEntrypoint := p.entrypoint
		p.entrypoint = ruleName
		if ruleName == "" {
			p.entrypoint = g.rules[0].name
		}
		return Entrypoint(oldEntrypoint)
	}
}

// Statistics adds a user provided Stats struct to the parser to allow
// the user to process the results after the parsing has finished.
// Also the key for the "no match" counter is set.
//
// Example usage:
//
//	input := "input"
//	stats := Stats{}
//	_, err := Parse("input-file", []byte(input), Statistics(&stats, "no match"))
//	if err != nil {
//	    log.Panicln(err)
//	}
//	b, err := json.MarshalIndent(stats.ChoiceAltCnt, "", "  ")
//	if err != nil {
//	    log.Panicln(err)
//	}
//	fmt.Println(string(b))
func Statistics(stats *Stats, choiceNoMatch string) Option {
	return func(p *parser) Option {
		oldStats := p.Stats
		p.Stats = stats
		oldChoiceNoMatch := p.choiceNoMatch
		p.choiceNoMatch = choiceNoMatch
		if p.Stats.ChoiceAltCnt == nil {
			p.Stats.ChoiceAltCnt = make(map[string]map[string]int)
		}
		return Statistics(oldStats, oldChoiceNoMatch)
	}
}

// Debug creates an Option to set the debug flag to b. When set to true,
// debugging information is printed to stdout while parsing.
//
// The default is false.
func Debug(b bool) Option {
	return func(p *parser) Option {
		old := p.debug
		p.debug = b
		return Debug(old)
	}
}

// Memoize creates an Option to set the memoize flag to b. When set to true,
// the parser will cache all results so each expression is evaluated only
// once. This guarantees linear parsing time even for pathological cases,
// at the expense of more memory and slower times for typical cases.
//
// The default is false.
func Memoize(b bool) Option {
	return func(p *parser) Option {
		old := p.memoize
		p.memoize = b
		return Memoize(old)
	}
}

// AllowInvalidUTF8 creates an Option to allow invalid UTF-8 bytes.
// Every invalid UTF-8 byte is treated as a utf8.RuneError (U+FFFD)
// by character class matchers and is matched by the any matcher.
// The returned matched value, c.text and c.offset are NOT affected.
//
// The default is false.
func AllowInvalidUTF8(b bool) Option {
	return func(p *parser) Option {
		old := p.allowInvalidUTF8
		p.allowInvalidUTF8 = b
		return AllowInvalidUTF8(old)
	}
}

// Recover creates an Option to set the recover flag to b. When set to
// true, this causes the parser to recover from panics and convert it
// to an error. Setting it to false can be useful while debugging to
// access the full stack trace.
//
// The default is true.
func Recover(b bool) Option {
	return func(p *parser) Option {
		old := p.recover
		p.recover = b
		return Recover(old)
	}
}

// GlobalStore creates an Option to set a key to a certain value in
// the globalStore.
func GlobalStore(key string, value any) Option {
	return func(p *parser) Option {
		old := p.cur.globalStore[key]
		p.cur.globalStore[key] = value
		return GlobalStore(key, old)
	}
}

// InitState creates an Option to set a key to a certain value in
// the global "state" store.
func InitState(key string, value any) Option {
	return func(p *parser) Option {
		old := p.cur.state[key]
		p.cur.state[key] = value
		return InitState(key, old)
	}
}

// ParseFile parses the file identified by filename.
func ParseFile(filename string, opts ...Option) (i any, err error) {
	f, err := os.Open(filename)
	if err != nil {
		return nil, err
	}
	defer func() {
		if closeErr := f.Close(); closeErr != nil {
			err = closeErr
		}
	}()
	return ParseReader(filename, f, opts...)
}

// ParseReader parses the data from r using filename as information in the
// error messages.
func ParseReader(filename string, r io.Reader, opts ...Option) (any, error) {
	b, err := io.ReadAll(r)
	if err != nil {
		return nil, err
	}

	return Parse(filename, b, opts...)
}

// Parse parses the data from b using filename as information in the
// error messages.
func Parse(filename string, b []byte, opts ...Option) (any, error) {
	return newParser(filename, b, opts...).parse(g)
}

// position records a position in the text.
type position struct {
	line, col, offset int
}

func (p position) String() string {
	return strconv.Itoa(p.line) + ":" + strconv.Itoa(p.col) + " [" + strconv.Itoa(p.offset) + "]"
}

// savepoint stores all state required to go back to this point in the
// parser.
type savepoint struct {
	position
	rn rune
	w  int
}

type current struct {
	pos  position // start position of the match
	text []byte   // raw text of the match

	// state is a store for arbitrary key,value pairs that the user wants to be
	// tied to the backtracking of the parser.
	// This is always rolled back if a parsing rule fails.
	state storeDict

	// globalStore is a general store for the user to store arbitrary key-value
	// pairs that they need to manage and that they do not want tied to the
	// backtracking of the parser. This is only modified by the user and never
	// rolled back by the parser. It is always up to the user to keep this in a
	// consistent state.
	globalStore storeDict
}

type storeDict map[string]any

// the AST types...

type grammar struct {
	pos   position
	rules []*rule
}

type rule struct {
	pos         position
	name        string
	displayName string
	expr        any
}

type choiceExpr struct {
	pos          position
	alternatives []any
}

type actionExpr struct {
	pos  position
	expr any
	run  func(*parser) (any, error)
}

type recoveryExpr struct {
	pos          position
	expr         any
	recoverExpr  any
	failureLabel []string
}

type seqExpr struct {
	pos   position
	exprs []any
}

type throwExpr struct {
	pos   position
	label string
}

type labeledExpr struct {
	pos   position
	label string
	expr  any
}

type expr struct {
	pos  position
	expr any
}

type (
	andExpr        expr
	notExpr        expr
	zeroOrOneExpr  expr
	zeroOrMoreExpr expr
	oneOrMoreExpr  expr
)

type ruleRefExpr struct {
	pos  position
	name string
}

type stateCodeExpr struct {
	pos position
	run func(*parser) error
}

type andCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type notCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type litMatcher struct {
	pos        position
	val        string
	ignoreCase bool
	want       string
}

type charClassMatcher struct {
	pos             position
	val             string
	basicLatinChars [128]bool
	chars           []rune
	ranges          []rune
	classes         []*unicode.RangeTable
	ignoreCase      bool
	inverted        bool
}

type anyMatcher position

// errList cumulates the errors found by the parser.
type errList []error

func (e *errList) add(err error) {
	*e = append(*e, err)
}

func (e errList) err() error {
	if len(e) == 0 {
		return nil
	}
	e.dedupe()
	return e
}

func (e *errList) dedupe() {
	var cleaned []error
	set := make(map[string]bool)
	for _, err := range *e {
		if msg := err.Error(); !set[msg] {
			set[msg] = true
			cleaned = append(cleaned, err)
		}
	}
	*e = cleaned
}

func (e errList) Error() string {
	switch len(e) {
	case 0:
		return ""
	case 1:
		return e[0].Error()
	default:
		var buf bytes.Buffer

		for i, err := range e {
			if i > 0 {
				buf.WriteRune('\n')
			}
			buf.WriteString(err.Error())
		}
		return buf.String()
	}
}

// parserError wraps an error with a prefix indicating the rule in which
// the error occurred. The original error is stored in the Inner field.
type parserError struct {
	Inner    error
	pos      position
	prefix   string
	expected []string
}

// Error returns the error message.
func (p *parserError) Error() string {
	return p.prefix + ": " + p.Inner.Error()
}

// newParser creates a parser with the specified input source and options.
func newParser(filename string, b []byte, opts ...Option) *parser {
	stats := Stats{
		ChoiceAltCnt: make(map[string]map[string]int),
	}

	p := &parser{
		filename: filename,
		errs:     new(errList),
		data:     b,
		pt:       savepoint{position: position{line: 1}},
		recover:  true,
		cur: current{
			state:       make(storeDict),
			globalStore: make(storeDict),
		},
		maxFailPos:      position{col: 1, line: 1},
		maxFailExpected: make([]string, 0, 20),
		Stats:           &stats,
		// start rule is rule [0] unless an alternate entrypoint is specified
		entrypoint: g.rules[0].name,
	}
	p.setOptions(opts)

	if p.maxExprCnt == 0 {
		p.maxExprCnt = math.MaxUint64
	}

	return p
}

// setOptions applies the options to the parser.
func (p *parser) setOptions(opts []Option) {
	for _, opt := range opts {
		opt(p)
	}
}

type resultTuple struct {
	v   any
	b   bool
	end savepoint
}

const choiceNoMatch = -1

// Stats stores some statistics, gathered during parsing
type Stats struct {
	// ExprCnt counts the number of expressions processed during parsing
	// This value is compared to the maximum number of expressions allowed
	// (set by the MaxExpressions option).
	ExprCnt uint64

	// ChoiceAltCnt is used to count for each ordered choice expression,
	// which alternative is used how may times.
	// These numbers allow to optimize the order of the ordered choice expression
	// to increase the performance of the parser
	//
	// The outer key of ChoiceAltCnt is composed of the name of the rule as well
	// as the line and the column of the ordered choice.
	// The inner key of ChoiceAltCnt is the number (one-based) of the matching alternative.
	// For each alternative the number of matches are counted. If an ordered choice does not
	// match, a special counter is incremented. The name of this counter is set with
	// the parser option Statistics.
	// For an alternative to be included in ChoiceAltCnt, it has to match at least once.
	ChoiceAltCnt map[string]map[string]int
}

type parser struct {
	filename string
	pt       savepoint
	cur      current

	data []byte
	errs *errList

	depth   int
	recover bool
	debug   bool

	memoize bool
	// memoization table for the packrat algorithm:
	// map[offset in source] map[expression or rule] {value, match}
	memo map[int]map[any]resultTuple

	// rules table, maps the rule identifier to the rule node
	rules map[string]*rule
	// variables stack, map of label to value
	vstack []map[string]any
	// rule stack, allows identification of the current rule in errors
	rstack []*rule

	// parse fail
	maxFailPos            position
	maxFailExpected       []string
	maxFailInvertExpected bool

	// max number of expressions to be parsed
	maxExprCnt uint64
	// entrypoint for the parser
	entrypoint string

	allowInvalidUTF8 bool

	*Stats

	choiceNoMatch string
	// recovery expression stack, keeps track of the currently available recovery expression, these are traversed in reverse
	recoveryStack []map[string]any
}

// push a variable set on the vstack.
func (p *parser) pushV() {
	if cap(p.vstack) == len(p.vstack) {
		// create new empty slot in the stack
		p.vstack = append(p.vstack, nil)
	} else {
		// slice to 1 more
		p.vstack = p.vstack[:len(p.vstack)+1]
	}

	// get the last args set
	m := p.vstack[len(p.vstack)-1]
	if m != nil && len(m) == 0 {
		// empty map, all good
		return
	}

	m = make(map[string]any)
	p.vstack[len(p.vstack)-1] = m
}

// pop a variable set from the vstack.
func (p *parser) popV() {
	// if the map is not empty, clear it
	m := p.vstack[len(p.vstack)-1]
	if len(m) > 0 {
		// GC that map
		p.vstack[len(p.vstack)-1] = nil
	}
	p.vstack = p.vstack[:len(p.vstack)-1]
}

// push a recovery expression with its labels to the recoveryStack
func (p *parser) pushRecovery(labels []string, expr any) {
	if cap(p.recoveryStack) == len(p.recoveryStack) {
		// create new empty slot in the stack
		p.recoveryStack = append(p.recoveryStack, nil)
	} else {
		// slice to 1 more
		p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)+1]
	}

	m := make(map[string]any, len(labels))
	for _, fl := range labels {
		m[fl] = expr
	}
	p.recoveryStack[len(p.recoveryStack)-1] = m
}

// pop a recovery expression from the recoveryStack
func (p *parser) popRecovery() {
	// GC that map
	p.recoveryStack[len(p.recoveryStack)-1] = nil

	p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)-1]
}

func (p *parser) print(prefix, s string) string {
	if !p.debug {
		return s
	}

	fmt.Printf("%s %d:%d:%d: %s [%#U]\n",
		prefix, p.pt.line, p.pt.col, p.pt.offset, s, p.pt.rn)
	return s
}

func (p *parser) printIndent(mark string, s string) string {
	return p.print(strings.Repeat(" ", p.depth)+mark, s)
}

func (p *parser) in(s string) string {
	res := p.printIndent(">", s)
	p.depth++
	return res
}

func (p *parser) out(s string) string {
	p.depth--
	return p.printIndent("<", s)
}

func (p *parser) addErr(err error) {
	p.addErrAt(err, p.pt.position, []string{})
}

func (p *parser) addErrAt(err error, pos position, expected []string) {
	var buf bytes.Buffer
	if p.filename != "" {
		buf.WriteString(p.filename)
	}
	if buf.Len() > 0 {
		buf.WriteString(":")
	}
	buf.WriteString(fmt.Sprintf("%d:%d (%d)", pos.line, pos.col, pos.offset))
	if len(p.rstack) > 0 {
		if buf.Len() > 0 {
			buf.WriteString(": ")
		}
		rule := p.rstack[len(p.rstack)-1]
		if rule.displayName != "" {
			buf.WriteString("rule " + rule.displayName)
		} else {
			buf.WriteString("rule " + rule.name)
		}
	}
	pe := &parserError{Inner: err, pos: pos, prefix: buf.String(), expected: expected}
	p.errs.add(pe)
}

func (p *parser) failAt(fail bool, pos position, want string) {
	// process fail if parsing fails and not inverted or parsing succeeds and invert is set
	if fail == p.maxFailInvertExpected {
		if pos.offset < p.maxFailPos.offset {
			return
		}

		if pos.offset > p.maxFailPos.offset {
			p.maxFailPos = pos
			p.maxFailExpected = p.maxFailExpected[:0]
		}

		if p.maxFailInvertExpected {
			want = "!" + want
		}
		p.maxFailExpected = append(p.maxFailExpected, want)
	}
}

// read advances the parser to the next rune.
func (p *parser) read() {
	p.pt.offset += p.pt.w
	rn, n := utf8.DecodeRune(p.data[p.pt.offset:])
	p.pt.rn = rn
	p.pt.w = n
	p.pt.col++
	if rn == '\n' {
		p.pt.line++
		p.pt.col = 0
	}

	if rn == utf8.RuneError && n == 1 { // see utf8.DecodeRune
		if !p.allowInvalidUTF8 {
			p.addErr(errInvalidEncoding)
		}
	}
}

// restore parser position to the savepoint pt.
func (p *parser) restore(pt savepoint) {
	if p.debug {
		defer p.out(p.in("restore"))
	}
	if pt.offset == p.pt.offset {
		return
	}
	p.pt = pt
}

// Cloner is implemented by any value that has a Clone method, which returns a
// copy of the value. This is mainly used for types which are not passed by
// value (e.g map, slice, chan) or structs that contain such types.
//
// This is used in conjunction with the global state feature to create proper
// copies of the state to allow the parser to properly restore the state in
// the case of backtracking.
type Cloner interface {
	Clone() any
}

var statePool = &sync.Pool{
	New: func() any { return make(storeDict) },
}

func (sd storeDict) Discard() {
	for k := range sd {
		delete(sd, k)
	}
	statePool.Put(sd)
}

// clone and return parser current state.
func (p *parser) cloneState() storeDict {
	if p.debug {
		defer p.out(p.in("cloneState"))
	}

	state := statePool.Get().(storeDict)
	for k, v := range p.cur.state {
		if c, ok := v.(Cloner); ok {
			state[k] = c.Clone()
		} else {
			state[k] = v
		}
	}
	return state
}

// restore parser current state to the state storeDict.
// every restoreState should applied only one time for every cloned state
func (p *parser) restoreState(state storeDict) {
	if p.debug {
		defer p.out(p.in("restoreState"))
	}
	p.cur.state.Discard()
	p.cur.state = state
}

// get the slice of bytes from the savepoint start to the current position.
func (p *parser) sliceFrom(start savepoint) []byte {
	return p.data[start.position.offset:p.pt.position.offset]
}

func (p *parser) getMemoized(node any) (resultTuple, bool) {
	if len(p.memo) == 0 {
		return resultTuple{}, false
	}
	m := p.memo[p.pt.offset]
	if len(m) == 0 {
		return resultTuple{}, false
	}
	res, ok := m[node]
	return res, ok
}

func (p *parser) setMemoized(pt savepoint, node any, tuple resultTuple) {
	if p.memo == nil {
		p.memo = make(map[int]map[any]resultTuple)
	}
	m := p.memo[pt.offset]
	if m == nil {
		m = make(map[any]resultTuple)
		p.memo[pt.offset] = m
	}
	m[node] = tuple
}

func (p *parser) buildRulesTable(g *grammar) {
	p.rules = make(map[string]*rule, len(g.rules))
	for _, r := range g.rules {
		p.rules[r.name] = r
	}
}

func (p *parser) parse(g *grammar) (val any, err error) {
	if len(g.rules) == 0 {
		p.addErr(errNoRule)
		return nil, p.errs.err()
	}

	// TODO : not super critical but this could be generated
	p.buildRulesTable(g)

	if p.recover {
		// panic can be used in action code to stop parsing immediately
		// and return the panic as an error.
		defer func() {
			if e := recover(); e != nil {
				if p.debug {
					defer p.out(p.in("panic handler"))
				}
				val = nil
				switch e := e.(type) {
				case error:
					p.addErr(e)
				default:
					p.addErr(fmt.Errorf("%v", e))
				}
				err = p.errs.err()
			}
		}()
	}

	startRule, ok := p.rules[p.entrypoint]
	if !ok {
		p.addErr(errInvalidEntrypoint)
		return nil, p.errs.err()
	}

	p.read() // advance to first rune
	val, ok = p.parseRuleWrap(startRule)
	if !ok {
		if len(*p.errs) == 0 {
			// If parsing fails, but no errors have been recorded, the expected values
			// for the farthest parser position are returned as error.
			maxFailExpectedMap := make(map[string]struct{}, len(p.maxFailExpected))
			for _, v := range p.maxFailExpected {
				maxFailExpectedMap[v] = struct{}{}
			}
			expected := make([]string, 0, len(maxFailExpectedMap))
			eof := false
			if _, ok := maxFailExpectedMap["!."]; ok {
				delete(maxFailExpectedMap, "!.")
				eof = true
			}
			for k := range maxFailExpectedMap {
				expected = append(expected, k)
			}
			sort.Strings(expected)
			if eof {
				expected = append(expected, "EOF")
			}
			p.addErrAt(errors.New("no match found, expected: "+listJoin(expected, ", ", "or")), p.maxFailPos, expected)
		}

		return nil, p.errs.err()
	}
	return val, p.errs.err()
}

func listJoin(list []string, sep string, lastSep string) string {
	switch len(list) {
	case 0:
		return ""
	case 1:
		return list[0]
	default:
		return strings.Join(list[:len(list)-1], sep) + " " + lastSep + " " + list[len(list)-1]
	}
}

func (p *parser) parseRuleMemoize(rule *rule) (any, bool) {
	res, ok := p.getMemoized(rule)
	if ok {
		p.restore(res.end)
		return res.v, res.b
	}

	startMark := p.pt
	val, ok := p.parseRule(rule)
	p.setMemoized(startMark, rule, resultTuple{val, ok, p.pt})

	return val, ok
}

func (p *parser) parseRuleWrap(rule *rule) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRule " + rule.name))
	}
	var (
		val       any
		ok        bool
		startMark = p.pt
	)

	if p.memoize {
		val, ok = p.parseRuleMemoize(rule)
	} else {
		val, ok = p.parseRule(rule)
	}

	if ok && p.debug {
		p.printIndent("MATCH", string(p.sliceFrom(startMark)))
	}
	return val, ok
}

func (p *parser) parseRule(rule *rule) (any, bool) {
	p.rstack = append(p.rstack, rule)
	p.pushV()
	val, ok := p.parseExprWrap(rule.expr)
	p.popV()
	p.rstack = p.rstack[:len(p.rstack)-1]
	return val, ok
}

func (p *parser) parseExprWrap(expr any) (any, bool) {
	var pt savepoint

	if p.memoize {
		res, ok := p.getMemoized(expr)
		if ok {
			p.restore(res.end)
			return res.v, res.b
		}
		pt = p.pt
	}

	val, ok := p.parseExpr(expr)

	if p.memoize {
		p.setMemoized(pt, expr, resultTuple{val, ok, p.pt})
	}
	return val, ok
}

func (p *parser) parseExpr(expr any) (any, bool) {
	p.ExprCnt++
	if p.ExprCnt > p.maxExprCnt {
		panic(errMaxExprCnt)
	}

	var val any
	var ok bool
	switch expr := expr.(type) {
	case *actionExpr:
		val, ok = p.parseActionExpr(expr)
	case *andCodeExpr:
		val, ok = p.parseAndCodeExpr(expr)
	case *andExpr:
		val, ok = p.parseAndExpr(expr)
	case *anyMatcher:
		val, ok = p.parseAnyMatcher(expr)
	case *charClassMatcher:
		val, ok = p.parseCharClassMatcher(expr)
	case *choiceExpr:
		val, ok = p.parseChoiceExpr(expr)
	case *labeledExpr:
		val, ok = p.parseLabeledExpr(expr)
	case *litMatcher:
		val, ok = p.parseLitMatcher(expr)
	case *notCodeExpr:
		val, ok = p.parseNotCodeExpr(expr)
	case *notExpr:
		val, ok = p.parseNotExpr(expr)
	case *oneOrMoreExpr:
		val, ok = p.parseOneOrMoreExpr(expr)
	case *recoveryExpr:
		val, ok = p.parseRecoveryExpr(expr)
	case *ruleRefExpr:
		val, ok = p.parseRuleRefExpr(expr)
	case *seqExpr:
		val, ok = p.parseSeqExpr(expr)
	case *stateCodeExpr:
		val, ok = p.parseStateCodeExpr(expr)
	case *throwExpr:
		val, ok = p.parseThrowExpr(expr)
	case *zeroOrMoreExpr:
		val, ok = p.parseZeroOrMoreExpr(expr)
	case *zeroOrOneExpr:
		val, ok = p.parseZeroOrOneExpr(expr)
	default:
		panic(fmt.Sprintf("unknown expression type %T", expr))
	}
	return val, ok
}

func (p *parser) parseActionExpr(act *actionExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseActionExpr"))
	}

	start := p.pt
	val, ok := p.parseExprWrap(act.expr)
	if ok {
		p.cur.pos = start.position
		p.cur.text = p.sliceFrom(start)
		state := p.cloneState()
		actVal, err := act.run(p)
		if err != nil {
			p.addErrAt(err, start.position, []string{})
		}
		p.restoreState(state)

		val = actVal
	}
	if ok && p.debug {
		p.printIndent("MATCH", string(p.sliceFrom(start)))
	}
	return val, ok
}

func (p *parser) parseAndCodeExpr(and *andCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAndCodeExpr"))
	}

	state := p.cloneState()

	ok, err := and.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, ok
}

func (p *parser) parseAndExpr(and *andExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAndExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	_, ok := p.parseExprWrap(and.expr)
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, ok
}

func (p *parser) parseAnyMatcher(any *anyMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAnyMatcher"))
	}

	if p.pt.rn == utf8.RuneError && p.pt.w == 0 {
		// EOF - see utf8.DecodeRune
		p.failAt(false, p.pt.position, ".")
		return nil, false
	}
	start := p.pt
	p.read()
	p.failAt(true, start.position, ".")
	return p.sliceFrom(start), true
}

func (p *parser) parseCharClassMatcher(chr *charClassMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseCharClassMatcher"))
	}

	cur := p.pt.rn
	start := p.pt

	// can't match EOF
	if cur == utf8.RuneError && p.pt.w == 0 { // see utf8.DecodeRune
		p.failAt(false, start.position, chr.val)
		return nil, false
	}

	if chr.ignoreCase {
		cur = unicode.ToLower(cur)
	}

	// try to match in the list of available chars
	for _, rn := range chr.chars {
		if rn == cur {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of ranges
	for i := 0; i < len(chr.ranges); i += 2 {
		if cur >= chr.ranges[i] && cur <= chr.ranges[i+1] {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of Unicode classes
	for _, cl := range chr.classes {
		if unicode.Is(cl, cur) {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	if chr.inverted {
		p.read()
		p.failAt(true, start.position, chr.val)
		return p.sliceFrom(start), true
	}
	p.failAt(false, start.position, chr.val)
	return nil, false
}

func (p *parser) incChoiceAltCnt(ch *choiceExpr, altI int) {
	choiceIdent := fmt.Sprintf("%s %d:%d", p.rstack[len(p.rstack)-1].name, ch.pos.line, ch.pos.col)
	m := p.ChoiceAltCnt[choiceIdent]
	if m == nil {
		m = make(map[string]int)
		p.ChoiceAltCnt[choiceIdent] = m
	}
	// We increment altI by 1, so the keys do not start at 0
	alt := strconv.Itoa(altI + 1)
	if altI == choiceNoMatch {
		alt = p.choiceNoMatch
	}
	m[alt]++
}

func (p *parser) parseChoiceExpr(ch *choiceExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseChoiceExpr"))
	}

	for altI, alt := range ch.alternatives {
		// dummy assignment to prevent compile error if optimized
		_ = altI

		state := p.cloneState()

		p.pushV()
		val, ok := p.parseExprWrap(alt)
		p.popV()
		if ok {
			p.incChoiceAltCnt(ch, altI)
			return val, ok
		}
		p.restoreState(state)
	}
	p.incChoiceAltCnt(ch, choiceNoMatch)
	return nil, false
}

func (p *parser) parseLabeledExpr(lab *labeledExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseLabeledExpr"))
	}

	p.pushV()
	val, ok := p.parseExprWrap(lab.expr)
	p.popV()
	if ok && lab.label != "" {
		m := p.vstack[len(p.vstack)-1]
		m[lab.label] = val
	}
	return val, ok
}

func (p *parser) parseLitMatcher(lit *litMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseLitMatcher"))
	}

	start := p.pt
	for _, want := range lit.val {
		cur := p.pt.rn
		if lit.ignoreCase {
			cur = unicode.ToLower(cur)
		}
		if cur != want {
			p.failAt(false, start.position, lit.want)
			p.restore(start)
			return nil, false
		}
		p.read()
	}
	p.failAt(true, start.position, lit.want)
	return p.sliceFrom(start), true
}

func (p *parser) parseNotCodeExpr(not *notCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseNotCodeExpr"))
	}

	state := p.cloneState()

	ok, err := not.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, !ok
}

func (p *parser) parseNotExpr(not *notExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseNotExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	_, ok := p.parseExprWrap(not.expr)
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, !ok
}

func (p *parser) parseOneOrMoreExpr(expr *oneOrMoreExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseOneOrMoreExpr"))
	}

	var vals []any

	for {
		p.pushV()
		val, ok := p.parseExprWrap(expr.expr)
		p.popV()
		if !ok {
			if len(vals) == 0 {
				// did not match once, no match
				return nil, false
			}
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseRecoveryExpr(recover *recoveryExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRecoveryExpr (" + strings.Join(recover.failureLabel, ",") + ")"))
	}

	p.pushRecovery(recover.failureLabel, recover.recoverExpr)
	val, ok := p.parseExprWrap(recover.expr)
	p.popRecovery()

	return val, ok
}

func (p *parser) parseRuleRefExpr(ref *ruleRefExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRuleRefExpr " + ref.name))
	}

	if ref.name == "" {
		panic(fmt.Sprintf("%s: invalid rule: missing name", ref.pos))
	}

	rule := p.rules[ref.name]
	if rule == nil {
		p.addErr(fmt.Errorf("undefined rule: %s", ref.name))
		return nil, false
	}
	return p.parseRuleWrap(rule)
}

func (p *parser) parseSeqExpr(seq *seqExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseSeqExpr"))
	}

	vals := make([]any, 0, len(seq.exprs))

	pt := p.pt
	state := p.cloneState()
	for _, expr := range seq.exprs {
		val, ok := p.parseExprWrap(expr)
		if !ok {
			p.restoreState(state)
			p.restore(pt)
			return nil, false
		}
		vals = append(vals, val)
	}
	return vals, true
}

func (p *parser) parseStateCodeExpr(state *stateCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseStateCodeExpr"))
	}

	err := state.run(p)
	if err != nil {
		p.addErr(err)
	}
	return nil, true
}

func (p *parser) parseThrowExpr(expr *throwExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseThrowExpr"))
	}

	for i := len(p.recoveryStack) - 1; i >= 0; i-- {
		if recoverExpr, ok := p.recoveryStack[i][expr.label]; ok {
			if val, ok := p.parseExprWrap(recoverExpr); ok {
				return val, ok
			}
		}
	}

	return nil, false
}

func (p *parser) parseZeroOrMoreExpr(expr *zeroOrMoreExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrMoreExpr"))
	}

	var vals []any

	for {
		p.pushV()
		val, ok := p.parseExprWrap(expr.expr)
		p.popV()
		if !ok {
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseZeroOrOneExpr(expr *zeroOrOneExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrOneExpr"))
	}

	p.pushV()
	val, _ := p.parseExprWrap(expr.expr)
	p.popV()
	// whether it matched or not, consider it a match
	return val, true
}
